      subroutine kinkk3(ikin,imom,ecm,m,p,x,ndim,dlips)
 
      use inprms
      use kincuts
      use ntnkin
 
      implicit none
 
      integer, parameter :: nepl=8
      integer :: ikin,imom,ndim
      real(dp) :: ecm,m(nepl),p(0:3,nepl),x(ndim),dlips,v(3),g
      real(dp), dimension(0:3) :: q1,q2,q3,q4
      real(dp) :: sqsl1,sqsl2,sqsl3,sqsl4
      real(dp) :: sqsu1,sqsu2,sqsu3,sqsu4
      real(dp) :: sqs1,sqs2,sqs3,sqs4
      real(dp) :: ds1,ds2,ds3,ds4
      real(dp) :: s1,s2,s3,s4
      real(dp) :: dl1,dl2,dl3,dl4
 
      if (ikin <= nt71) then                                                    
       sqsl1=m(3)+m(6)                                                          
       sqsl2=m(4)+sqsl1                                                         
       sqsl3=m(7)+m(8)                                                          
       sqsl4=sqsl3+m(5)                                                         
       if (imom /= 1) then                                                      
        q1=p(:,3)+p(:,6)                                                        
        q2=p(:,4)+q1                                                            
        q3=p(:,7)+p(:,8)                                                        
        q4=q3+p(:,5)                                                            
       end if                                                                   
       if (ikin == 95) then                                                     
       sqsu2=ecm-sqsl4                                                          
       call mapakk(imom,x(2),q2,sqscut,sqsl2,sqsu2,s2,sqs2,ds2)                 
       sqsu1=sqs2-m(4)                                                          
       call mapakk(imom,x(1),q1,sqscut,sqsl1,sqsu1,s1,sqs1,ds1)                 
       sqsu4=ecm-sqs2                                                           
       call mapakk(imom,x(4),q4,sqscut,sqsl4,sqsu4,s4,sqs4,ds4)                 
       sqsu3=sqs4-m(5)                                                          
       call mapbkk(imom,x(3),q3,mw,gamw,sqsl3,sqsu3,s3,sqs3,ds3)                
       end if                                                                   
       if (ikin == 96) then
       sqsu2=ecm-sqsl4
       call mapakk(imom,x(2),q2,sqscut,sqsl2,sqsu2,s2,sqs2,ds2)
       sqsu1=sqs2-m(4)
       call mapakk(imom,x(1),q1,sqscut,sqsl1,sqsu1,s1,sqs1,ds1)
       sqsu4=ecm-sqs2
       call mapakk(imom,x(4),q4,sqscut,sqsl4,sqsu4,s4,sqs4,ds4)
       sqsu3=sqs4-m(5)
       call mapbkk(imom,x(3),q3,mw,gamw,sqsl3,sqsu3,s3,sqs3,ds3)
       end if
       if (ikin == 97) then
       sqsu2=ecm-sqsl4
       call mapbkk(imom,x(2),q2,mz,gamz,sqsl2,sqsu2,s2,sqs2,ds2)
       sqsu1=sqs2-m(4)
       call mapakk(imom,x(1),q1,sqscut,sqsl1,sqsu1,s1,sqs1,ds1)
       sqsu4=ecm-sqs2
       call mapbkk(imom,x(4),q4,mz,gamz,sqsl4,sqsu4,s4,sqs4,ds4)
       sqsu3=sqs4-m(5)
       call mapbkk(imom,x(3),q3,mw,gamw,sqsl3,sqsu3,s3,sqs3,ds3)
       end if
       if (ikin == 98) then
       sqsu2=ecm-sqsl4
       call mapakk(imom,x(2),q2,sqscut,sqsl2,sqsu2,s2,sqs2,ds2)
       sqsu1=sqs2-m(4)
       call mapakk(imom,x(1),q1,sqscut,sqsl1,sqsu1,s1,sqs1,ds1)
       sqsu4=ecm-sqs2
       call mapakk(imom,x(4),q4,sqscut,sqsl4,sqsu4,s4,sqs4,ds4)
       sqsu3=sqs4-m(5)
       call mapbkk(imom,x(3),q3,mw,gamw,sqsl3,sqsu3,s3,sqs3,ds3)
       end if
       if (ikin == 99) then
       sqsu2=ecm-sqsl4
       call mapakk(imom,x(2),q2,sqscut,sqsl2,sqsu2,s2,sqs2,ds2)
       sqsu1=sqs2-m(4)
       call mapakk(imom,x(1),q1,sqscut,sqsl1,sqsu1,s1,sqs1,ds1)
       sqsu4=ecm-sqs2
       call mapakk(imom,x(4),q4,sqscut,sqsl4,sqsu4,s4,sqs4,ds4)
       sqsu3=sqs4-m(5)
       call mapbkk(imom,x(3),q3,mw,gamw,sqsl3,sqsu3,s3,sqs3,ds3)
       end if
       if (ikin == 100) then
       sqsu2=ecm-sqsl4
       call mapbkk(imom,x(2),q2,mz,gamz,sqsl2,sqsu2,s2,sqs2,ds2)
       sqsu1=sqs2-m(4)
       call mapakk(imom,x(1),q1,sqscut,sqsl1,sqsu1,s1,sqs1,ds1)
       sqsu4=ecm-sqs2
       call mapbkk(imom,x(4),q4,mz,gamz,sqsl4,sqsu4,s4,sqs4,ds4)
       sqsu3=sqs4-m(5)
       call mapbkk(imom,x(3),q3,mw,gamw,sqsl3,sqsu3,s3,sqs3,ds3)
       end if
       if (ikin == 101) then
       sqsu2=ecm-sqsl4
       call mapakk(imom,x(2),q2,sqscut,sqsl2,sqsu2,s2,sqs2,ds2)
       sqsu1=sqs2-m(4)
       call mapbkk(imom,x(1),q1,mz,gamz,sqsl1,sqsu1,s1,sqs1,ds1)
       sqsu4=ecm-sqs2
       call mapakk(imom,x(4),q4,sqscut,sqsl4,sqsu4,s4,sqs4,ds4)
       sqsu3=sqs4-m(5)
       call mapbkk(imom,x(3),q3,mw,gamw,sqsl3,sqsu3,s3,sqs3,ds3)
       end if
       if (ikin == 102) then
       sqsu2=ecm-sqsl4
       call mapakk(imom,x(2),q2,sqscut,sqsl2,sqsu2,s2,sqs2,ds2)
       sqsu1=sqs2-m(4)
       call mapbkk(imom,x(1),q1,mz,gamz,sqsl1,sqsu1,s1,sqs1,ds1)
       sqsu4=ecm-sqs2
       call mapakk(imom,x(4),q4,sqscut,sqsl4,sqsu4,s4,sqs4,ds4)
       sqsu3=sqs4-m(5)
       call mapbkk(imom,x(3),q3,mw,gamw,sqsl3,sqsu3,s3,sqs3,ds3)
       end if
       if (ikin == 103) then
       sqsu2=ecm-sqsl4
       call mapbkk(imom,x(2),q2,mz,gamz,sqsl2,sqsu2,s2,sqs2,ds2)
       sqsu1=sqs2-m(4)
       call mapbkk(imom,x(1),q1,mz,gamz,sqsl1,sqsu1,s1,sqs1,ds1)
       sqsu4=ecm-sqs2
       call mapbkk(imom,x(4),q4,mz,gamz,sqsl4,sqsu4,s4,sqs4,ds4)
       sqsu3=sqs4-m(5)
       call mapbkk(imom,x(3),q3,mw,gamw,sqsl3,sqsu3,s3,sqs3,ds3)
       end if
       call kinff(imom,sqs1,m(3),m(6),x(5:6),p(:,3),p(:,6),dl1)
       call kinff(imom,sqs2,m(4),sqs1,x(7:8),p(:,4),q1,dl2)
       call kinff(imom,sqs3,m(7),m(8),x(9:10),p(:,7),p(:,8),dl3)
       call kinff(imom,sqs4,sqs3,m(5),x(11:12),q3,p(:,5),dl4)
       call kinff(imom,ecm,sqs2,sqs4,x(13:14),q2,q4,dlips)
       dlips=dlips*ds1*ds2*ds3*ds4
     &            *dl1*dl2*dl3*dl4
       if (dlips <= 0.d0) then
        dlips=0.d0
        return
       end if
       if (imom == 1 .and. dlips > 0.d0) then
        v=q1(1:)/q1(0)
        g=q1(0)/sqs1
        call boost(g,v,p(:,3))
        call boost(g,v,p(:,6))
        v=q2(1:)/q2(0)
        g=q2(0)/sqs2
        call boost(g,v,p(:,4))
        call boost(g,v,p(:,3))
        call boost(g,v,p(:,6))
        v=q3(1:)/q3(0)
        g=q3(0)/sqs3
        call boost(g,v,p(:,7))
        call boost(g,v,p(:,8))
        v=q4(1:)/q4(0)
        g=q4(0)/sqs4
        call boost(g,v,p(:,7))
        call boost(g,v,p(:,8))
        call boost(g,v,p(:,5))
       end if
      else if (ikin <= nt72) then
       sqsl1=m(3)+m(6)
       sqsl2=m(4)+sqsl1
       sqsl3=m(7)+m(8)
       sqsl4=sqsl3+m(5)
       if (imom /= 1) then
        q1=p(:,3)+p(:,6)
        q2=p(:,4)+q1
        q3=p(:,7)+p(:,8)
        q4=q3+p(:,5)
       end if
       if (ikin == 104) then
       sqsu2=ecm-sqsl4
       call mapakk(imom,x(2),q2,sqscut,sqsl2,sqsu2,s2,sqs2,ds2)
       sqsu1=sqs2-m(4)
       call mapakk(imom,x(1),q1,sqscut,sqsl1,sqsu1,s1,sqs1,ds1)
       sqsu4=ecm-sqs2
       call mapbkk(imom,x(4),q4,mu,zero,sqsl4,sqsu4,s4,sqs4,ds4)
       sqsu3=sqs4-m(5)
       call mapbkk(imom,x(3),q3,mw,gamw,sqsl3,sqsu3,s3,sqs3,ds3)
       end if
       if (ikin == 105) then
       sqsu2=ecm-sqsl4
       call mapakk(imom,x(2),q2,sqscut,sqsl2,sqsu2,s2,sqs2,ds2)
       sqsu1=sqs2-m(4)
       call mapakk(imom,x(1),q1,sqscut,sqsl1,sqsu1,s1,sqs1,ds1)
       sqsu4=ecm-sqs2
       call mapbkk(imom,x(4),q4,mu,zero,sqsl4,sqsu4,s4,sqs4,ds4)
       sqsu3=sqs4-m(5)
       call mapbkk(imom,x(3),q3,mw,gamw,sqsl3,sqsu3,s3,sqs3,ds3)
       end if
       if (ikin == 106) then
       sqsu2=ecm-sqsl4
       call mapbkk(imom,x(2),q2,mz,gamz,sqsl2,sqsu2,s2,sqs2,ds2)
       sqsu1=sqs2-m(4)
       call mapakk(imom,x(1),q1,sqscut,sqsl1,sqsu1,s1,sqs1,ds1)
       sqsu4=ecm-sqs2
       call mapbkk(imom,x(4),q4,mu,zero,sqsl4,sqsu4,s4,sqs4,ds4)
       sqsu3=sqs4-m(5)
       call mapbkk(imom,x(3),q3,mw,gamw,sqsl3,sqsu3,s3,sqs3,ds3)
       end if
       if (ikin == 107) then
       sqsu2=ecm-sqsl4
       call mapakk(imom,x(2),q2,sqscut,sqsl2,sqsu2,s2,sqs2,ds2)
       sqsu1=sqs2-m(4)
       call mapakk(imom,x(1),q1,sqscut,sqsl1,sqsu1,s1,sqs1,ds1)
       sqsu4=ecm-sqs2
       call mapbkk(imom,x(4),q4,mu,zero,sqsl4,sqsu4,s4,sqs4,ds4)
       sqsu3=sqs4-m(5)
       call mapbkk(imom,x(3),q3,mw,gamw,sqsl3,sqsu3,s3,sqs3,ds3)
       end if
       if (ikin == 108) then
       sqsu2=ecm-sqsl4
       call mapakk(imom,x(2),q2,sqscut,sqsl2,sqsu2,s2,sqs2,ds2)
       sqsu1=sqs2-m(4)
       call mapakk(imom,x(1),q1,sqscut,sqsl1,sqsu1,s1,sqs1,ds1)
       sqsu4=ecm-sqs2
       call mapbkk(imom,x(4),q4,mu,zero,sqsl4,sqsu4,s4,sqs4,ds4)
       sqsu3=sqs4-m(5)
       call mapbkk(imom,x(3),q3,mw,gamw,sqsl3,sqsu3,s3,sqs3,ds3)
       end if
       if (ikin == 109) then
       sqsu2=ecm-sqsl4
       call mapbkk(imom,x(2),q2,mz,gamz,sqsl2,sqsu2,s2,sqs2,ds2)
       sqsu1=sqs2-m(4)
       call mapakk(imom,x(1),q1,sqscut,sqsl1,sqsu1,s1,sqs1,ds1)
       sqsu4=ecm-sqs2
       call mapbkk(imom,x(4),q4,mu,zero,sqsl4,sqsu4,s4,sqs4,ds4)
       sqsu3=sqs4-m(5)
       call mapbkk(imom,x(3),q3,mw,gamw,sqsl3,sqsu3,s3,sqs3,ds3)
       end if
       if (ikin == 110) then
       sqsu2=ecm-sqsl4
       call mapakk(imom,x(2),q2,sqscut,sqsl2,sqsu2,s2,sqs2,ds2)
       sqsu1=sqs2-m(4)
       call mapbkk(imom,x(1),q1,mz,gamz,sqsl1,sqsu1,s1,sqs1,ds1)
       sqsu4=ecm-sqs2
       call mapbkk(imom,x(4),q4,mu,zero,sqsl4,sqsu4,s4,sqs4,ds4)
       sqsu3=sqs4-m(5)
       call mapbkk(imom,x(3),q3,mw,gamw,sqsl3,sqsu3,s3,sqs3,ds3)
       end if
       if (ikin == 111) then
       sqsu2=ecm-sqsl4
       call mapakk(imom,x(2),q2,sqscut,sqsl2,sqsu2,s2,sqs2,ds2)
       sqsu1=sqs2-m(4)
       call mapbkk(imom,x(1),q1,mz,gamz,sqsl1,sqsu1,s1,sqs1,ds1)
       sqsu4=ecm-sqs2
       call mapbkk(imom,x(4),q4,mu,zero,sqsl4,sqsu4,s4,sqs4,ds4)
       sqsu3=sqs4-m(5)
       call mapbkk(imom,x(3),q3,mw,gamw,sqsl3,sqsu3,s3,sqs3,ds3)
       end if
       if (ikin == 112) then
       sqsu2=ecm-sqsl4
       call mapbkk(imom,x(2),q2,mz,gamz,sqsl2,sqsu2,s2,sqs2,ds2)
       sqsu1=sqs2-m(4)
       call mapbkk(imom,x(1),q1,mz,gamz,sqsl1,sqsu1,s1,sqs1,ds1)
       sqsu4=ecm-sqs2
       call mapbkk(imom,x(4),q4,mu,zero,sqsl4,sqsu4,s4,sqs4,ds4)
       sqsu3=sqs4-m(5)
       call mapbkk(imom,x(3),q3,mw,gamw,sqsl3,sqsu3,s3,sqs3,ds3)
       end if
       call kinff(imom,sqs1,m(3),m(6),x(5:6),p(:,3),p(:,6),dl1)
       call kinff(imom,sqs2,m(4),sqs1,x(7:8),p(:,4),q1,dl2)
       call kinff(imom,sqs3,m(7),m(8),x(9:10),p(:,7),p(:,8),dl3)
       call kinff(imom,sqs4,sqs3,m(5),x(11:12),q3,p(:,5),dl4)
       call kinff(imom,ecm,sqs2,sqs4,x(13:14),q2,q4,dlips)
       dlips=dlips*ds1*ds2*ds3*ds4
     &            *dl1*dl2*dl3*dl4
       if (dlips <= 0.d0) then
        dlips=0.d0
        return
       end if
       if (imom == 1 .and. dlips > 0.d0) then
        v=q1(1:)/q1(0)
        g=q1(0)/sqs1
        call boost(g,v,p(:,3))
        call boost(g,v,p(:,6))
        v=q2(1:)/q2(0)
        g=q2(0)/sqs2
        call boost(g,v,p(:,4))
        call boost(g,v,p(:,3))
        call boost(g,v,p(:,6))
        v=q3(1:)/q3(0)
        g=q3(0)/sqs3
        call boost(g,v,p(:,7))
        call boost(g,v,p(:,8))
        v=q4(1:)/q4(0)
        g=q4(0)/sqs4
        call boost(g,v,p(:,7))
        call boost(g,v,p(:,8))
        call boost(g,v,p(:,5))
       end if
      else if (ikin <= nt73) then
       sqsl1=m(3)+m(6)
       sqsl2=m(4)+sqsl1
       sqsl3=m(5)+m(8)
       sqsl4=m(7)+sqsl3
       if (imom /= 1) then
        q1=p(:,3)+p(:,6)
        q2=p(:,4)+q1
        q3=p(:,5)+p(:,8)
        q4=p(:,7)+q3
       end if
       if (ikin == 113) then
       sqsu2=ecm-sqsl4
       call mapakk(imom,x(2),q2,sqscut,sqsl2,sqsu2,s2,sqs2,ds2)
       sqsu1=sqs2-m(4)
       call mapakk(imom,x(1),q1,sqscut,sqsl1,sqsu1,s1,sqs1,ds1)
       sqsu4=ecm-sqs2
       call mapakk(imom,x(4),q4,sqscut,sqsl4,sqsu4,s4,sqs4,ds4)
       sqsu3=sqs4-m(7)
       call mapbkk(imom,x(3),q3,mmu,zero,sqsl3,sqsu3,s3,sqs3,ds3)
       end if
       if (ikin == 114) then
       sqsu2=ecm-sqsl4
       call mapbkk(imom,x(2),q2,mz,gamz,sqsl2,sqsu2,s2,sqs2,ds2)
       sqsu1=sqs2-m(4)
       call mapakk(imom,x(1),q1,sqscut,sqsl1,sqsu1,s1,sqs1,ds1)
       sqsu4=ecm-sqs2
       call mapbkk(imom,x(4),q4,mz,gamz,sqsl4,sqsu4,s4,sqs4,ds4)
       sqsu3=sqs4-m(7)
       call mapbkk(imom,x(3),q3,mmu,zero,sqsl3,sqsu3,s3,sqs3,ds3)
       end if
       if (ikin == 115) then
       sqsu2=ecm-sqsl4
       call mapakk(imom,x(2),q2,sqscut,sqsl2,sqsu2,s2,sqs2,ds2)
       sqsu1=sqs2-m(4)
       call mapakk(imom,x(1),q1,sqscut,sqsl1,sqsu1,s1,sqs1,ds1)
       sqsu4=ecm-sqs2
       call mapakk(imom,x(4),q4,sqscut,sqsl4,sqsu4,s4,sqs4,ds4)
       sqsu3=sqs4-m(7)
       call mapbkk(imom,x(3),q3,mmu,zero,sqsl3,sqsu3,s3,sqs3,ds3)
       end if
       if (ikin == 116) then
       sqsu2=ecm-sqsl4
       call mapbkk(imom,x(2),q2,mz,gamz,sqsl2,sqsu2,s2,sqs2,ds2)
       sqsu1=sqs2-m(4)
       call mapakk(imom,x(1),q1,sqscut,sqsl1,sqsu1,s1,sqs1,ds1)
       sqsu4=ecm-sqs2
       call mapbkk(imom,x(4),q4,mz,gamz,sqsl4,sqsu4,s4,sqs4,ds4)
       sqsu3=sqs4-m(7)
       call mapbkk(imom,x(3),q3,mmu,zero,sqsl3,sqsu3,s3,sqs3,ds3)
       end if
       if (ikin == 117) then
       sqsu2=ecm-sqsl4
       call mapakk(imom,x(2),q2,sqscut,sqsl2,sqsu2,s2,sqs2,ds2)
       sqsu1=sqs2-m(4)
       call mapbkk(imom,x(1),q1,mz,gamz,sqsl1,sqsu1,s1,sqs1,ds1)
       sqsu4=ecm-sqs2
       call mapakk(imom,x(4),q4,sqscut,sqsl4,sqsu4,s4,sqs4,ds4)
       sqsu3=sqs4-m(7)
       call mapbkk(imom,x(3),q3,mmu,zero,sqsl3,sqsu3,s3,sqs3,ds3)
       end if
       if (ikin == 118) then
       sqsu2=ecm-sqsl4
       call mapbkk(imom,x(2),q2,mz,gamz,sqsl2,sqsu2,s2,sqs2,ds2)
       sqsu1=sqs2-m(4)
       call mapbkk(imom,x(1),q1,mz,gamz,sqsl1,sqsu1,s1,sqs1,ds1)
       sqsu4=ecm-sqs2
       call mapbkk(imom,x(4),q4,mz,gamz,sqsl4,sqsu4,s4,sqs4,ds4)
       sqsu3=sqs4-m(7)
       call mapbkk(imom,x(3),q3,mmu,zero,sqsl3,sqsu3,s3,sqs3,ds3)
       end if
       call kinff(imom,sqs1,m(3),m(6),x(5:6),p(:,3),p(:,6),dl1)
       call kinff(imom,sqs2,m(4),sqs1,x(7:8),p(:,4),q1,dl2)
       call kinff(imom,sqs3,m(5),m(8),x(9:10),p(:,5),p(:,8),dl3)
       call kinff(imom,sqs4,m(7),sqs3,x(11:12),p(:,7),q3,dl4)
       call kinff(imom,ecm,sqs2,sqs4,x(13:14),q2,q4,dlips)
       dlips=dlips*ds1*ds2*ds3*ds4
     &            *dl1*dl2*dl3*dl4
       if (dlips <= 0.d0) then
        dlips=0.d0
        return
       end if
       if (imom == 1 .and. dlips > 0.d0) then
        v=q1(1:)/q1(0)
        g=q1(0)/sqs1
        call boost(g,v,p(:,3))
        call boost(g,v,p(:,6))
        v=q2(1:)/q2(0)
        g=q2(0)/sqs2
        call boost(g,v,p(:,4))
        call boost(g,v,p(:,3))
        call boost(g,v,p(:,6))
        v=q3(1:)/q3(0)
        g=q3(0)/sqs3
        call boost(g,v,p(:,5))
        call boost(g,v,p(:,8))
        v=q4(1:)/q4(0)
        g=q4(0)/sqs4
        call boost(g,v,p(:,7))
        call boost(g,v,p(:,5))
        call boost(g,v,p(:,8))
       end if
      else if (ikin <= nt74) then
       sqsl1=m(3)+m(6)
       sqsl2=m(4)+sqsl1
       sqsl3=m(7)+m(8)
       sqsl4=m(5)+sqsl3
       if (imom /= 1) then
        q1=p(:,3)+p(:,6)
        q2=p(:,4)+q1
        q3=p(:,7)+p(:,8)
        q4=p(:,5)+q3
       end if
       if (ikin == 119) then
       sqsu2=ecm-sqsl4
       call mapakk(imom,x(2),q2,sqscut,sqsl2,sqsu2,s2,sqs2,ds2)
       sqsu1=sqs2-m(4)
       call mapakk(imom,x(1),q1,sqscut,sqsl1,sqsu1,s1,sqs1,ds1)
       sqsu4=ecm-sqs2
       call mapakk(imom,x(4),q4,sqscut,sqsl4,sqsu4,s4,sqs4,ds4)
       sqsu3=sqs4-m(5)
       call mapbkk(imom,x(3),q3,mw,gamw,sqsl3,sqsu3,s3,sqs3,ds3)
       end if
       if (ikin == 120) then
       sqsu2=ecm-sqsl4
       call mapbkk(imom,x(2),q2,mz,gamz,sqsl2,sqsu2,s2,sqs2,ds2)
       sqsu1=sqs2-m(4)
       call mapakk(imom,x(1),q1,sqscut,sqsl1,sqsu1,s1,sqs1,ds1)
       sqsu4=ecm-sqs2
       call mapbkk(imom,x(4),q4,mz,gamz,sqsl4,sqsu4,s4,sqs4,ds4)
       sqsu3=sqs4-m(5)
       call mapbkk(imom,x(3),q3,mw,gamw,sqsl3,sqsu3,s3,sqs3,ds3)
       end if
       if (ikin == 121) then
       sqsu2=ecm-sqsl4
       call mapakk(imom,x(2),q2,sqscut,sqsl2,sqsu2,s2,sqs2,ds2)
       sqsu1=sqs2-m(4)
       call mapakk(imom,x(1),q1,sqscut,sqsl1,sqsu1,s1,sqs1,ds1)
       sqsu4=ecm-sqs2
       call mapakk(imom,x(4),q4,sqscut,sqsl4,sqsu4,s4,sqs4,ds4)
       sqsu3=sqs4-m(5)
       call mapbkk(imom,x(3),q3,mw,gamw,sqsl3,sqsu3,s3,sqs3,ds3)
       end if
       if (ikin == 122) then
       sqsu2=ecm-sqsl4
       call mapbkk(imom,x(2),q2,mz,gamz,sqsl2,sqsu2,s2,sqs2,ds2)
       sqsu1=sqs2-m(4)
       call mapakk(imom,x(1),q1,sqscut,sqsl1,sqsu1,s1,sqs1,ds1)
       sqsu4=ecm-sqs2
       call mapbkk(imom,x(4),q4,mz,gamz,sqsl4,sqsu4,s4,sqs4,ds4)
       sqsu3=sqs4-m(5)
       call mapbkk(imom,x(3),q3,mw,gamw,sqsl3,sqsu3,s3,sqs3,ds3)
       end if
       if (ikin == 123) then
       sqsu2=ecm-sqsl4
       call mapakk(imom,x(2),q2,sqscut,sqsl2,sqsu2,s2,sqs2,ds2)
       sqsu1=sqs2-m(4)
       call mapbkk(imom,x(1),q1,mz,gamz,sqsl1,sqsu1,s1,sqs1,ds1)
       sqsu4=ecm-sqs2
       call mapakk(imom,x(4),q4,sqscut,sqsl4,sqsu4,s4,sqs4,ds4)
       sqsu3=sqs4-m(5)
       call mapbkk(imom,x(3),q3,mw,gamw,sqsl3,sqsu3,s3,sqs3,ds3)
       end if
       if (ikin == 124) then
       sqsu2=ecm-sqsl4
       call mapbkk(imom,x(2),q2,mz,gamz,sqsl2,sqsu2,s2,sqs2,ds2)
       sqsu1=sqs2-m(4)
       call mapbkk(imom,x(1),q1,mz,gamz,sqsl1,sqsu1,s1,sqs1,ds1)
       sqsu4=ecm-sqs2
       call mapbkk(imom,x(4),q4,mz,gamz,sqsl4,sqsu4,s4,sqs4,ds4)
       sqsu3=sqs4-m(5)
       call mapbkk(imom,x(3),q3,mw,gamw,sqsl3,sqsu3,s3,sqs3,ds3)
       end if
       call kinff(imom,sqs1,m(3),m(6),x(5:6),p(:,3),p(:,6),dl1)
       call kinff(imom,sqs2,m(4),sqs1,x(7:8),p(:,4),q1,dl2)
       call kinff(imom,sqs3,m(7),m(8),x(9:10),p(:,7),p(:,8),dl3)
       call kinff(imom,sqs4,m(5),sqs3,x(11:12),p(:,5),q3,dl4)
       call kinff(imom,ecm,sqs2,sqs4,x(13:14),q2,q4,dlips)
       dlips=dlips*ds1*ds2*ds3*ds4
     &            *dl1*dl2*dl3*dl4
       if (dlips <= 0.d0) then
        dlips=0.d0
        return
       end if
       if (imom == 1 .and. dlips > 0.d0) then
        v=q1(1:)/q1(0)
        g=q1(0)/sqs1
        call boost(g,v,p(:,3))
        call boost(g,v,p(:,6))
        v=q2(1:)/q2(0)
        g=q2(0)/sqs2
        call boost(g,v,p(:,4))
        call boost(g,v,p(:,3))
        call boost(g,v,p(:,6))
        v=q3(1:)/q3(0)
        g=q3(0)/sqs3
        call boost(g,v,p(:,7))
        call boost(g,v,p(:,8))
        v=q4(1:)/q4(0)
        g=q4(0)/sqs4
        call boost(g,v,p(:,5))
        call boost(g,v,p(:,7))
        call boost(g,v,p(:,8))
       end if
      else if (ikin <= nt75) then
       sqsl1=m(3)+m(6)
       sqsl2=m(4)+sqsl1
       sqsl3=m(7)+m(5)
       sqsl4=sqsl3+m(8)
       if (imom /= 1) then
        q1=p(:,3)+p(:,6)
        q2=p(:,4)+q1
        q3=p(:,7)+p(:,5)
        q4=q3+p(:,8)
       end if
       if (ikin == 125) then
       sqsu2=ecm-sqsl4
       call mapbkk(imom,x(2),q2,mz,gamz,sqsl2,sqsu2,s2,sqs2,ds2)
       sqsu1=sqs2-m(4)
       call mapakk(imom,x(1),q1,sqscut,sqsl1,sqsu1,s1,sqs1,ds1)
       sqsu4=ecm-sqs2
       call mapbkk(imom,x(4),q4,mz,gamz,sqsl4,sqsu4,s4,sqs4,ds4)
       sqsu3=sqs4-m(8)
       call mapbkk(imom,x(3),q3,zero,zero,sqsl3,sqsu3,s3,sqs3,ds3)
       end if
       if (ikin == 126) then
       sqsu2=ecm-sqsl4
       call mapbkk(imom,x(2),q2,mz,gamz,sqsl2,sqsu2,s2,sqs2,ds2)
       sqsu1=sqs2-m(4)
       call mapakk(imom,x(1),q1,sqscut,sqsl1,sqsu1,s1,sqs1,ds1)
       sqsu4=ecm-sqs2
       call mapbkk(imom,x(4),q4,mz,gamz,sqsl4,sqsu4,s4,sqs4,ds4)
       sqsu3=sqs4-m(8)
       call mapbkk(imom,x(3),q3,zero,zero,sqsl3,sqsu3,s3,sqs3,ds3)
       end if
       if (ikin == 127) then
       sqsu2=ecm-sqsl4
       call mapbkk(imom,x(2),q2,mz,gamz,sqsl2,sqsu2,s2,sqs2,ds2)
       sqsu1=sqs2-m(4)
       call mapbkk(imom,x(1),q1,mz,gamz,sqsl1,sqsu1,s1,sqs1,ds1)
       sqsu4=ecm-sqs2
       call mapbkk(imom,x(4),q4,mz,gamz,sqsl4,sqsu4,s4,sqs4,ds4)
       sqsu3=sqs4-m(8)
       call mapbkk(imom,x(3),q3,zero,zero,sqsl3,sqsu3,s3,sqs3,ds3)
       end if
       call kinff(imom,sqs1,m(3),m(6),x(5:6),p(:,3),p(:,6),dl1)
       call kinff(imom,sqs2,m(4),sqs1,x(7:8),p(:,4),q1,dl2)
       call kinff(imom,sqs3,m(7),m(5),x(9:10),p(:,7),p(:,5),dl3)
       call kinff(imom,sqs4,sqs3,m(8),x(11:12),q3,p(:,8),dl4)
       call kinff(imom,ecm,sqs2,sqs4,x(13:14),q2,q4,dlips)
       dlips=dlips*ds1*ds2*ds3*ds4
     &            *dl1*dl2*dl3*dl4
       if (dlips <= 0.d0) then
        dlips=0.d0
        return
       end if
       if (imom == 1 .and. dlips > 0.d0) then
        v=q1(1:)/q1(0)
        g=q1(0)/sqs1
        call boost(g,v,p(:,3))
        call boost(g,v,p(:,6))
        v=q2(1:)/q2(0)
        g=q2(0)/sqs2
        call boost(g,v,p(:,4))
        call boost(g,v,p(:,3))
        call boost(g,v,p(:,6))
        v=q3(1:)/q3(0)
        g=q3(0)/sqs3
        call boost(g,v,p(:,7))
        call boost(g,v,p(:,5))
        v=q4(1:)/q4(0)
        g=q4(0)/sqs4
        call boost(g,v,p(:,7))
        call boost(g,v,p(:,5))
        call boost(g,v,p(:,8))
       end if
      else if (ikin <= nt76) then
       sqsl1=m(3)+m(6)
       sqsl2=m(7)+m(8)
       sqsl3=m(4)+sqsl2
       sqsl4=sqsl3+m(5)
       if (imom /= 1) then
        q1=p(:,3)+p(:,6)
        q2=p(:,7)+p(:,8)
        q3=p(:,4)+q2
        q4=q3+p(:,5)
       end if
       if (ikin == 128) then
       sqsu1=ecm-sqsl4
       call mapakk(imom,x(1),q1,sqscut,sqsl1,sqsu1,s1,sqs1,ds1)
       sqsu4=ecm-sqs1
       call mapbkk(imom,x(4),q4,mu,zero,sqsl4,sqsu4,s4,sqs4,ds4)
       sqsu3=sqs4-m(5)
       call mapbkk(imom,x(3),q3,md,zero,sqsl3,sqsu3,s3,sqs3,ds3)
       sqsu2=sqs3-m(4)
       call mapbkk(imom,x(2),q2,mw,gamw,sqsl2,sqsu2,s2,sqs2,ds2)
       end if
       if (ikin == 129) then
       sqsu1=ecm-sqsl4
       call mapakk(imom,x(1),q1,sqscut,sqsl1,sqsu1,s1,sqs1,ds1)
       sqsu4=ecm-sqs1
       call mapbkk(imom,x(4),q4,mu,zero,sqsl4,sqsu4,s4,sqs4,ds4)
       sqsu3=sqs4-m(5)
       call mapbkk(imom,x(3),q3,md,zero,sqsl3,sqsu3,s3,sqs3,ds3)
       sqsu2=sqs3-m(4)
       call mapbkk(imom,x(2),q2,mw,gamw,sqsl2,sqsu2,s2,sqs2,ds2)
       end if
       if (ikin == 130) then
       sqsu1=ecm-sqsl4
       call mapbkk(imom,x(1),q1,mz,gamz,sqsl1,sqsu1,s1,sqs1,ds1)
       sqsu4=ecm-sqs1
       call mapbkk(imom,x(4),q4,mu,zero,sqsl4,sqsu4,s4,sqs4,ds4)
       sqsu3=sqs4-m(5)
       call mapbkk(imom,x(3),q3,md,zero,sqsl3,sqsu3,s3,sqs3,ds3)
       sqsu2=sqs3-m(4)
       call mapbkk(imom,x(2),q2,mw,gamw,sqsl2,sqsu2,s2,sqs2,ds2)
       end if
       call kinff(imom,sqs1,m(3),m(6),x(5:6),p(:,3),p(:,6),dl1)
       call kinff(imom,sqs2,m(7),m(8),x(7:8),p(:,7),p(:,8),dl2)
       call kinff(imom,sqs3,m(4),sqs2,x(9:10),p(:,4),q2,dl3)
       call kinff(imom,sqs4,sqs3,m(5),x(11:12),q3,p(:,5),dl4)
       call kinff(imom,ecm,sqs1,sqs4,x(13:14),q1,q4,dlips)
       dlips=dlips*ds1*ds2*ds3*ds4
     &            *dl1*dl2*dl3*dl4
       if (dlips <= 0.d0) then
        dlips=0.d0
        return
       end if
       if (imom == 1 .and. dlips > 0.d0) then
        v=q1(1:)/q1(0)
        g=q1(0)/sqs1
        call boost(g,v,p(:,3))
        call boost(g,v,p(:,6))
        v=q2(1:)/q2(0)
        g=q2(0)/sqs2
        call boost(g,v,p(:,7))
        call boost(g,v,p(:,8))
        v=q3(1:)/q3(0)
        g=q3(0)/sqs3
        call boost(g,v,p(:,4))
        call boost(g,v,p(:,7))
        call boost(g,v,p(:,8))
        v=q4(1:)/q4(0)
        g=q4(0)/sqs4
        call boost(g,v,p(:,4))
        call boost(g,v,p(:,7))
        call boost(g,v,p(:,8))
        call boost(g,v,p(:,5))
       end if
      else if (ikin <= nt77) then
       sqsl1=m(3)+m(6)
       sqsl2=m(7)+m(8)
       sqsl3=m(4)+sqsl2
       sqsl4=sqsl3+m(5)
       if (imom /= 1) then
        q1=p(:,3)+p(:,6)
        q2=p(:,7)+p(:,8)
        q3=p(:,4)+q2
        q4=q3+p(:,5)
       end if
       if (ikin == 131) then
       sqsu1=ecm-sqsl4
       call mapakk(imom,x(1),q1,sqscut,sqsl1,sqsu1,s1,sqs1,ds1)
       sqsu4=ecm-sqs1
       call mapakk(imom,x(4),q4,sqscut,sqsl4,sqsu4,s4,sqs4,ds4)
       sqsu3=sqs4-m(5)
       call mapbkk(imom,x(3),q3,md,zero,sqsl3,sqsu3,s3,sqs3,ds3)
       sqsu2=sqs3-m(4)
       call mapbkk(imom,x(2),q2,mw,gamw,sqsl2,sqsu2,s2,sqs2,ds2)
       end if
       if (ikin == 132) then
       sqsu1=ecm-sqsl4
       call mapakk(imom,x(1),q1,sqscut,sqsl1,sqsu1,s1,sqs1,ds1)
       sqsu4=ecm-sqs1
       call mapbkk(imom,x(4),q4,mz,gamz,sqsl4,sqsu4,s4,sqs4,ds4)
       sqsu3=sqs4-m(5)
       call mapbkk(imom,x(3),q3,md,zero,sqsl3,sqsu3,s3,sqs3,ds3)
       sqsu2=sqs3-m(4)
       call mapbkk(imom,x(2),q2,mw,gamw,sqsl2,sqsu2,s2,sqs2,ds2)
       end if
       if (ikin == 133) then
       sqsu1=ecm-sqsl4
       call mapakk(imom,x(1),q1,sqscut,sqsl1,sqsu1,s1,sqs1,ds1)
       sqsu4=ecm-sqs1
       call mapakk(imom,x(4),q4,sqscut,sqsl4,sqsu4,s4,sqs4,ds4)
       sqsu3=sqs4-m(5)
       call mapbkk(imom,x(3),q3,md,zero,sqsl3,sqsu3,s3,sqs3,ds3)
       sqsu2=sqs3-m(4)
       call mapbkk(imom,x(2),q2,mw,gamw,sqsl2,sqsu2,s2,sqs2,ds2)
       end if
       if (ikin == 134) then
       sqsu1=ecm-sqsl4
       call mapakk(imom,x(1),q1,sqscut,sqsl1,sqsu1,s1,sqs1,ds1)
       sqsu4=ecm-sqs1
       call mapbkk(imom,x(4),q4,mz,gamz,sqsl4,sqsu4,s4,sqs4,ds4)
       sqsu3=sqs4-m(5)
       call mapbkk(imom,x(3),q3,md,zero,sqsl3,sqsu3,s3,sqs3,ds3)
       sqsu2=sqs3-m(4)
       call mapbkk(imom,x(2),q2,mw,gamw,sqsl2,sqsu2,s2,sqs2,ds2)
       end if
       if (ikin == 135) then
       sqsu1=ecm-sqsl4
       call mapbkk(imom,x(1),q1,mz,gamz,sqsl1,sqsu1,s1,sqs1,ds1)
       sqsu4=ecm-sqs1
       call mapakk(imom,x(4),q4,sqscut,sqsl4,sqsu4,s4,sqs4,ds4)
       sqsu3=sqs4-m(5)
       call mapbkk(imom,x(3),q3,md,zero,sqsl3,sqsu3,s3,sqs3,ds3)
       sqsu2=sqs3-m(4)
       call mapbkk(imom,x(2),q2,mw,gamw,sqsl2,sqsu2,s2,sqs2,ds2)
       end if
       if (ikin == 136) then
       sqsu1=ecm-sqsl4
       call mapbkk(imom,x(1),q1,mz,gamz,sqsl1,sqsu1,s1,sqs1,ds1)
       sqsu4=ecm-sqs1
       call mapakk(imom,x(4),q4,sqscut,sqsl4,sqsu4,s4,sqs4,ds4)
       sqsu3=sqs4-m(5)
       call mapbkk(imom,x(3),q3,md,zero,sqsl3,sqsu3,s3,sqs3,ds3)
       sqsu2=sqs3-m(4)
       call mapbkk(imom,x(2),q2,mw,gamw,sqsl2,sqsu2,s2,sqs2,ds2)
       end if
       call kinff(imom,sqs1,m(3),m(6),x(5:6),p(:,3),p(:,6),dl1)
       call kinff(imom,sqs2,m(7),m(8),x(7:8),p(:,7),p(:,8),dl2)
       call kinff(imom,sqs3,m(4),sqs2,x(9:10),p(:,4),q2,dl3)
       call kinff(imom,sqs4,sqs3,m(5),x(11:12),q3,p(:,5),dl4)
       call kinff(imom,ecm,sqs1,sqs4,x(13:14),q1,q4,dlips)
       dlips=dlips*ds1*ds2*ds3*ds4
     &            *dl1*dl2*dl3*dl4
       if (dlips <= 0.d0) then
        dlips=0.d0
        return
       end if
       if (imom == 1 .and. dlips > 0.d0) then
        v=q1(1:)/q1(0)
        g=q1(0)/sqs1
        call boost(g,v,p(:,3))
        call boost(g,v,p(:,6))
        v=q2(1:)/q2(0)
        g=q2(0)/sqs2
        call boost(g,v,p(:,7))
        call boost(g,v,p(:,8))
        v=q3(1:)/q3(0)
        g=q3(0)/sqs3
        call boost(g,v,p(:,4))
        call boost(g,v,p(:,7))
        call boost(g,v,p(:,8))
        v=q4(1:)/q4(0)
        g=q4(0)/sqs4
        call boost(g,v,p(:,4))
        call boost(g,v,p(:,7))
        call boost(g,v,p(:,8))
        call boost(g,v,p(:,5))
       end if
      else if (ikin <= nt78) then
       sqsl1=m(3)+m(6)
       sqsl2=m(7)+m(8)
       sqsl3=sqsl2+m(5)
       sqsl4=m(4)+sqsl3
       if (imom /= 1) then
        q1=p(:,3)+p(:,6)
        q2=p(:,7)+p(:,8)
        q3=q2+p(:,5)
        q4=p(:,4)+q3
       end if
       if (ikin == 137) then
       sqsu1=ecm-sqsl4
       call mapakk(imom,x(1),q1,sqscut,sqsl1,sqsu1,s1,sqs1,ds1)
       sqsu4=ecm-sqs1
       call mapakk(imom,x(4),q4,sqscut,sqsl4,sqsu4,s4,sqs4,ds4)
       sqsu3=sqs4-m(4)
       call mapbkk(imom,x(3),q3,mu,zero,sqsl3,sqsu3,s3,sqs3,ds3)
       sqsu2=sqs3-m(5)
       call mapbkk(imom,x(2),q2,mw,gamw,sqsl2,sqsu2,s2,sqs2,ds2)
       end if
       if (ikin == 138) then
       sqsu1=ecm-sqsl4
       call mapakk(imom,x(1),q1,sqscut,sqsl1,sqsu1,s1,sqs1,ds1)
       sqsu4=ecm-sqs1
       call mapbkk(imom,x(4),q4,mz,gamz,sqsl4,sqsu4,s4,sqs4,ds4)
       sqsu3=sqs4-m(4)
       call mapbkk(imom,x(3),q3,mu,zero,sqsl3,sqsu3,s3,sqs3,ds3)
       sqsu2=sqs3-m(5)
       call mapbkk(imom,x(2),q2,mw,gamw,sqsl2,sqsu2,s2,sqs2,ds2)
       end if
       if (ikin == 139) then
       sqsu1=ecm-sqsl4
       call mapakk(imom,x(1),q1,sqscut,sqsl1,sqsu1,s1,sqs1,ds1)
       sqsu4=ecm-sqs1
       call mapakk(imom,x(4),q4,sqscut,sqsl4,sqsu4,s4,sqs4,ds4)
       sqsu3=sqs4-m(4)
       call mapbkk(imom,x(3),q3,mu,zero,sqsl3,sqsu3,s3,sqs3,ds3)
       sqsu2=sqs3-m(5)
       call mapbkk(imom,x(2),q2,mw,gamw,sqsl2,sqsu2,s2,sqs2,ds2)
       end if
       if (ikin == 140) then
       sqsu1=ecm-sqsl4
       call mapakk(imom,x(1),q1,sqscut,sqsl1,sqsu1,s1,sqs1,ds1)
       sqsu4=ecm-sqs1
       call mapbkk(imom,x(4),q4,mz,gamz,sqsl4,sqsu4,s4,sqs4,ds4)
       sqsu3=sqs4-m(4)
       call mapbkk(imom,x(3),q3,mu,zero,sqsl3,sqsu3,s3,sqs3,ds3)
       sqsu2=sqs3-m(5)
       call mapbkk(imom,x(2),q2,mw,gamw,sqsl2,sqsu2,s2,sqs2,ds2)
       end if
       if (ikin == 141) then
       sqsu1=ecm-sqsl4
       call mapbkk(imom,x(1),q1,mz,gamz,sqsl1,sqsu1,s1,sqs1,ds1)
       sqsu4=ecm-sqs1
       call mapakk(imom,x(4),q4,sqscut,sqsl4,sqsu4,s4,sqs4,ds4)
       sqsu3=sqs4-m(4)
       call mapbkk(imom,x(3),q3,mu,zero,sqsl3,sqsu3,s3,sqs3,ds3)
       sqsu2=sqs3-m(5)
       call mapbkk(imom,x(2),q2,mw,gamw,sqsl2,sqsu2,s2,sqs2,ds2)
       end if
       if (ikin == 142) then
       sqsu1=ecm-sqsl4
       call mapbkk(imom,x(1),q1,mz,gamz,sqsl1,sqsu1,s1,sqs1,ds1)
       sqsu4=ecm-sqs1
       call mapakk(imom,x(4),q4,sqscut,sqsl4,sqsu4,s4,sqs4,ds4)
       sqsu3=sqs4-m(4)
       call mapbkk(imom,x(3),q3,mu,zero,sqsl3,sqsu3,s3,sqs3,ds3)
       sqsu2=sqs3-m(5)
       call mapbkk(imom,x(2),q2,mw,gamw,sqsl2,sqsu2,s2,sqs2,ds2)
       end if
       call kinff(imom,sqs1,m(3),m(6),x(5:6),p(:,3),p(:,6),dl1)
       call kinff(imom,sqs2,m(7),m(8),x(7:8),p(:,7),p(:,8),dl2)
       call kinff(imom,sqs3,sqs2,m(5),x(9:10),q2,p(:,5),dl3)
       call kinff(imom,sqs4,m(4),sqs3,x(11:12),p(:,4),q3,dl4)
       call kinff(imom,ecm,sqs1,sqs4,x(13:14),q1,q4,dlips)
       dlips=dlips*ds1*ds2*ds3*ds4
     &            *dl1*dl2*dl3*dl4
       if (dlips <= 0.d0) then
        dlips=0.d0
        return
       end if
       if (imom == 1 .and. dlips > 0.d0) then
        v=q1(1:)/q1(0)
        g=q1(0)/sqs1
        call boost(g,v,p(:,3))
        call boost(g,v,p(:,6))
        v=q2(1:)/q2(0)
        g=q2(0)/sqs2
        call boost(g,v,p(:,7))
        call boost(g,v,p(:,8))
        v=q3(1:)/q3(0)
        g=q3(0)/sqs3
        call boost(g,v,p(:,7))
        call boost(g,v,p(:,8))
        call boost(g,v,p(:,5))
        v=q4(1:)/q4(0)
        g=q4(0)/sqs4
        call boost(g,v,p(:,4))
        call boost(g,v,p(:,7))
        call boost(g,v,p(:,8))
        call boost(g,v,p(:,5))
       end if
      else if (ikin <= nt79) then
       sqsl1=m(3)+m(6)
       sqsl2=m(7)+m(8)
       sqsl3=m(4)+m(5)
       sqsl4=sqsl2+sqsl3
       if (imom /= 1) then
        q1=p(:,3)+p(:,6)
        q2=p(:,7)+p(:,8)
        q3=p(:,4)+p(:,5)
        q4=q2+q3
       end if
       if (ikin == 143) then
       sqsu1=ecm-sqsl4
       call mapakk(imom,x(1),q1,sqscut,sqsl1,sqsu1,s1,sqs1,ds1)
       sqsu4=ecm-sqs1
       ds4=(sqsu4-sqsl4)*(sqsu4+sqsl4)
       if (imom == 1) then
        s4=ds4*x(4)+sqsl4*sqsl4
       else
        s4=(q4(0)-q4(3))*(q4(0)+q4(3))-q4(1)*q4(1)-q4(2)*q4(2)
       end if
       sqs4=sqrt(s4)
       sqsu3=sqs4-sqsl2
       call mapbkk(imom,x(3),q3,mw,gamw,sqsl3,sqsu3,s3,sqs3,ds3)
       sqsu2=sqs4-sqs3
       call mapbkk(imom,x(2),q2,mw,gamw,sqsl2,sqsu2,s2,sqs2,ds2)
       end if
       if (ikin == 144) then
       sqsu1=ecm-sqsl4
       call mapakk(imom,x(1),q1,sqscut,sqsl1,sqsu1,s1,sqs1,ds1)
       sqsu4=ecm-sqs1
       ds4=(sqsu4-sqsl4)*(sqsu4+sqsl4)
       if (imom == 1) then
        s4=ds4*x(4)+sqsl4*sqsl4
       else
        s4=(q4(0)-q4(3))*(q4(0)+q4(3))-q4(1)*q4(1)-q4(2)*q4(2)
       end if
       sqs4=sqrt(s4)
       sqsu3=sqs4-sqsl2
       call mapbkk(imom,x(3),q3,mw,gamw,sqsl3,sqsu3,s3,sqs3,ds3)
       sqsu2=sqs4-sqs3
       call mapbkk(imom,x(2),q2,mw,gamw,sqsl2,sqsu2,s2,sqs2,ds2)
       end if
       if (ikin == 145) then
       sqsu1=ecm-sqsl4
       call mapbkk(imom,x(1),q1,mz,gamz,sqsl1,sqsu1,s1,sqs1,ds1)
       sqsu4=ecm-sqs1
       ds4=(sqsu4-sqsl4)*(sqsu4+sqsl4)
       if (imom == 1) then
        s4=ds4*x(4)+sqsl4*sqsl4
       else
        s4=(q4(0)-q4(3))*(q4(0)+q4(3))-q4(1)*q4(1)-q4(2)*q4(2)
       end if
       sqs4=sqrt(s4)
       sqsu3=sqs4-sqsl2
       call mapbkk(imom,x(3),q3,mw,gamw,sqsl3,sqsu3,s3,sqs3,ds3)
       sqsu2=sqs4-sqs3
       call mapbkk(imom,x(2),q2,mw,gamw,sqsl2,sqsu2,s2,sqs2,ds2)
       end if
       call kinff(imom,sqs1,m(3),m(6),x(5:6),p(:,3),p(:,6),dl1)
       call kinff(imom,sqs2,m(7),m(8),x(7:8),p(:,7),p(:,8),dl2)
       call kinff(imom,sqs3,m(4),m(5),x(9:10),p(:,4),p(:,5),dl3)
       call kinff(imom,sqs4,sqs2,sqs3,x(11:12),q2,q3,dl4)
       call kinff(imom,ecm,sqs1,sqs4,x(13:14),q1,q4,dlips)
       dlips=dlips*ds1*ds2*ds3*ds4
     &            *dl1*dl2*dl3*dl4
       if (dlips <= 0.d0) then
        dlips=0.d0
        return
       end if
       if (imom == 1 .and. dlips > 0.d0) then
        v=q1(1:)/q1(0)
        g=q1(0)/sqs1
        call boost(g,v,p(:,3))
        call boost(g,v,p(:,6))
        v=q2(1:)/q2(0)
        g=q2(0)/sqs2
        call boost(g,v,p(:,7))
        call boost(g,v,p(:,8))
        v=q3(1:)/q3(0)
        g=q3(0)/sqs3
        call boost(g,v,p(:,4))
        call boost(g,v,p(:,5))
        v=q4(1:)/q4(0)
        g=q4(0)/sqs4
        call boost(g,v,p(:,7))
        call boost(g,v,p(:,8))
        call boost(g,v,p(:,4))
        call boost(g,v,p(:,5))
       end if
      else if (ikin <= nt80) then
       sqsl1=m(3)+m(6)
       sqsl2=m(4)+m(5)
       sqsl3=sqsl2+m(8)
       sqsl4=m(7)+sqsl3
       if (imom /= 1) then
        q1=p(:,3)+p(:,6)
        q2=p(:,4)+p(:,5)
        q3=q2+p(:,8)
        q4=p(:,7)+q3
       end if
       if (ikin == 146) then
       sqsu1=ecm-sqsl4
       call mapakk(imom,x(1),q1,sqscut,sqsl1,sqsu1,s1,sqs1,ds1)
       sqsu4=ecm-sqs1
       call mapakk(imom,x(4),q4,sqscut,sqsl4,sqsu4,s4,sqs4,ds4)
       sqsu3=sqs4-m(7)
       call mapbkk(imom,x(3),q3,mmu,zero,sqsl3,sqsu3,s3,sqs3,ds3)
       sqsu2=sqs3-m(8)
       call mapbkk(imom,x(2),q2,mw,gamw,sqsl2,sqsu2,s2,sqs2,ds2)
       end if
       if (ikin == 147) then
       sqsu1=ecm-sqsl4
       call mapakk(imom,x(1),q1,sqscut,sqsl1,sqsu1,s1,sqs1,ds1)
       sqsu4=ecm-sqs1
       call mapbkk(imom,x(4),q4,mz,gamz,sqsl4,sqsu4,s4,sqs4,ds4)
       sqsu3=sqs4-m(7)
       call mapbkk(imom,x(3),q3,mmu,zero,sqsl3,sqsu3,s3,sqs3,ds3)
       sqsu2=sqs3-m(8)
       call mapbkk(imom,x(2),q2,mw,gamw,sqsl2,sqsu2,s2,sqs2,ds2)
       end if
       if (ikin == 148) then
       sqsu1=ecm-sqsl4
       call mapakk(imom,x(1),q1,sqscut,sqsl1,sqsu1,s1,sqs1,ds1)
       sqsu4=ecm-sqs1
       call mapbkk(imom,x(4),q4,mz,gamz,sqsl4,sqsu4,s4,sqs4,ds4)
       sqsu3=sqs4-m(7)
       call mapbkk(imom,x(3),q3,mmu,zero,sqsl3,sqsu3,s3,sqs3,ds3)
       sqsu2=sqs3-m(8)
       call mapbkk(imom,x(2),q2,mw,gamw,sqsl2,sqsu2,s2,sqs2,ds2)
       end if
       if (ikin == 149) then
       sqsu1=ecm-sqsl4
       call mapbkk(imom,x(1),q1,mz,gamz,sqsl1,sqsu1,s1,sqs1,ds1)
       sqsu4=ecm-sqs1
       call mapakk(imom,x(4),q4,sqscut,sqsl4,sqsu4,s4,sqs4,ds4)
       sqsu3=sqs4-m(7)
       call mapbkk(imom,x(3),q3,mmu,zero,sqsl3,sqsu3,s3,sqs3,ds3)
       sqsu2=sqs3-m(8)
       call mapbkk(imom,x(2),q2,mw,gamw,sqsl2,sqsu2,s2,sqs2,ds2)
       end if
       call kinff(imom,sqs1,m(3),m(6),x(5:6),p(:,3),p(:,6),dl1)
       call kinff(imom,sqs2,m(4),m(5),x(7:8),p(:,4),p(:,5),dl2)
       call kinff(imom,sqs3,sqs2,m(8),x(9:10),q2,p(:,8),dl3)
       call kinff(imom,sqs4,m(7),sqs3,x(11:12),p(:,7),q3,dl4)
       call kinff(imom,ecm,sqs1,sqs4,x(13:14),q1,q4,dlips)
       dlips=dlips*ds1*ds2*ds3*ds4
     &            *dl1*dl2*dl3*dl4
       if (dlips <= 0.d0) then
        dlips=0.d0
        return
       end if
       if (imom == 1 .and. dlips > 0.d0) then
        v=q1(1:)/q1(0)
        g=q1(0)/sqs1
        call boost(g,v,p(:,3))
        call boost(g,v,p(:,6))
        v=q2(1:)/q2(0)
        g=q2(0)/sqs2
        call boost(g,v,p(:,4))
        call boost(g,v,p(:,5))
        v=q3(1:)/q3(0)
        g=q3(0)/sqs3
        call boost(g,v,p(:,4))
        call boost(g,v,p(:,5))
        call boost(g,v,p(:,8))
        v=q4(1:)/q4(0)
        g=q4(0)/sqs4
        call boost(g,v,p(:,7))
        call boost(g,v,p(:,4))
        call boost(g,v,p(:,5))
        call boost(g,v,p(:,8))
       end if
      else if (ikin <= nt81) then
       sqsl1=m(3)+m(6)
       sqsl2=m(4)+m(5)
       sqsl3=m(7)+m(8)
       sqsl4=sqsl2+sqsl3
       if (imom /= 1) then
        q1=p(:,3)+p(:,6)
        q2=p(:,4)+p(:,5)
        q3=p(:,7)+p(:,8)
        q4=q2+q3
       end if
       if (ikin == 150) then
       sqsu1=ecm-sqsl4
       call mapakk(imom,x(1),q1,sqscut,sqsl1,sqsu1,s1,sqs1,ds1)
       sqsu4=ecm-sqs1
       call mapakk(imom,x(4),q4,sqscut,sqsl4,sqsu4,s4,sqs4,ds4)
       sqsu3=sqs4-sqsl2
       call mapbkk(imom,x(3),q3,mw,gamw,sqsl3,sqsu3,s3,sqs3,ds3)
       sqsu2=sqs4-sqs3
       call mapbkk(imom,x(2),q2,mw,gamw,sqsl2,sqsu2,s2,sqs2,ds2)
       end if
       if (ikin == 151) then
       sqsu1=ecm-sqsl4
       call mapakk(imom,x(1),q1,sqscut,sqsl1,sqsu1,s1,sqs1,ds1)
       sqsu4=ecm-sqs1
       call mapbkk(imom,x(4),q4,mz,gamz,sqsl4,sqsu4,s4,sqs4,ds4)
       sqsu3=sqs4-sqsl2
       call mapbkk(imom,x(3),q3,mw,gamw,sqsl3,sqsu3,s3,sqs3,ds3)
       sqsu2=sqs4-sqs3
       call mapbkk(imom,x(2),q2,mw,gamw,sqsl2,sqsu2,s2,sqs2,ds2)
       end if
       if (ikin == 152) then
       sqsu1=ecm-sqsl4
       call mapakk(imom,x(1),q1,sqscut,sqsl1,sqsu1,s1,sqs1,ds1)
       sqsu4=ecm-sqs1
       call mapbkk(imom,x(4),q4,mz,gamz,sqsl4,sqsu4,s4,sqs4,ds4)
       sqsu3=sqs4-sqsl2
       call mapbkk(imom,x(3),q3,mw,gamw,sqsl3,sqsu3,s3,sqs3,ds3)
       sqsu2=sqs4-sqs3
       call mapbkk(imom,x(2),q2,mw,gamw,sqsl2,sqsu2,s2,sqs2,ds2)
       end if
       if (ikin == 153) then
       sqsu1=ecm-sqsl4
       call mapbkk(imom,x(1),q1,mz,gamz,sqsl1,sqsu1,s1,sqs1,ds1)
       sqsu4=ecm-sqs1
       call mapakk(imom,x(4),q4,sqscut,sqsl4,sqsu4,s4,sqs4,ds4)
       sqsu3=sqs4-sqsl2
       call mapbkk(imom,x(3),q3,mw,gamw,sqsl3,sqsu3,s3,sqs3,ds3)
       sqsu2=sqs4-sqs3
       call mapbkk(imom,x(2),q2,mw,gamw,sqsl2,sqsu2,s2,sqs2,ds2)
       end if
       call kinff(imom,sqs1,m(3),m(6),x(5:6),p(:,3),p(:,6),dl1)
       call kinff(imom,sqs2,m(4),m(5),x(7:8),p(:,4),p(:,5),dl2)
       call kinff(imom,sqs3,m(7),m(8),x(9:10),p(:,7),p(:,8),dl3)
       call kinff(imom,sqs4,sqs2,sqs3,x(11:12),q2,q3,dl4)
       call kinff(imom,ecm,sqs1,sqs4,x(13:14),q1,q4,dlips)
       dlips=dlips*ds1*ds2*ds3*ds4
     &            *dl1*dl2*dl3*dl4
       if (dlips <= 0.d0) then
        dlips=0.d0
        return
       end if
       if (imom == 1 .and. dlips > 0.d0) then
        v=q1(1:)/q1(0)
        g=q1(0)/sqs1
        call boost(g,v,p(:,3))
        call boost(g,v,p(:,6))
        v=q2(1:)/q2(0)
        g=q2(0)/sqs2
        call boost(g,v,p(:,4))
        call boost(g,v,p(:,5))
        v=q3(1:)/q3(0)
        g=q3(0)/sqs3
        call boost(g,v,p(:,7))
        call boost(g,v,p(:,8))
        v=q4(1:)/q4(0)
        g=q4(0)/sqs4
        call boost(g,v,p(:,4))
        call boost(g,v,p(:,5))
        call boost(g,v,p(:,7))
        call boost(g,v,p(:,8))
       end if
      else if (ikin <= nt82) then
       sqsl1=m(3)+m(6)
       sqsl2=m(4)+m(5)
       sqsl3=m(7)+sqsl2
       sqsl4=sqsl3+m(8)
       if (imom /= 1) then
        q1=p(:,3)+p(:,6)
        q2=p(:,4)+p(:,5)
        q3=p(:,7)+q2
        q4=q3+p(:,8)
       end if
       if (ikin == 154) then
       sqsu1=ecm-sqsl4
       call mapakk(imom,x(1),q1,sqscut,sqsl1,sqsu1,s1,sqs1,ds1)
       sqsu4=ecm-sqs1
       call mapbkk(imom,x(4),q4,mz,gamz,sqsl4,sqsu4,s4,sqs4,ds4)
       sqsu3=sqs4-m(8)
       call mapbkk(imom,x(3),q3,zero,zero,sqsl3,sqsu3,s3,sqs3,ds3)
       sqsu2=sqs3-m(7)
       call mapbkk(imom,x(2),q2,mw,gamw,sqsl2,sqsu2,s2,sqs2,ds2)
       end if
       if (ikin == 155) then
       sqsu1=ecm-sqsl4
       call mapakk(imom,x(1),q1,sqscut,sqsl1,sqsu1,s1,sqs1,ds1)
       sqsu4=ecm-sqs1
       call mapbkk(imom,x(4),q4,mz,gamz,sqsl4,sqsu4,s4,sqs4,ds4)
       sqsu3=sqs4-m(8)
       call mapbkk(imom,x(3),q3,zero,zero,sqsl3,sqsu3,s3,sqs3,ds3)
       sqsu2=sqs3-m(7)
       call mapbkk(imom,x(2),q2,mw,gamw,sqsl2,sqsu2,s2,sqs2,ds2)
       end if
       call kinff(imom,sqs1,m(3),m(6),x(5:6),p(:,3),p(:,6),dl1)
       call kinff(imom,sqs2,m(4),m(5),x(7:8),p(:,4),p(:,5),dl2)
       call kinff(imom,sqs3,m(7),sqs2,x(9:10),p(:,7),q2,dl3)
       call kinff(imom,sqs4,sqs3,m(8),x(11:12),q3,p(:,8),dl4)
       call kinff(imom,ecm,sqs1,sqs4,x(13:14),q1,q4,dlips)
       dlips=dlips*ds1*ds2*ds3*ds4
     &            *dl1*dl2*dl3*dl4
       if (dlips <= 0.d0) then
        dlips=0.d0
        return
       end if
       if (imom == 1 .and. dlips > 0.d0) then
        v=q1(1:)/q1(0)
        g=q1(0)/sqs1
        call boost(g,v,p(:,3))
        call boost(g,v,p(:,6))
        v=q2(1:)/q2(0)
        g=q2(0)/sqs2
        call boost(g,v,p(:,4))
        call boost(g,v,p(:,5))
        v=q3(1:)/q3(0)
        g=q3(0)/sqs3
        call boost(g,v,p(:,7))
        call boost(g,v,p(:,4))
        call boost(g,v,p(:,5))
        v=q4(1:)/q4(0)
        g=q4(0)/sqs4
        call boost(g,v,p(:,7))
        call boost(g,v,p(:,4))
        call boost(g,v,p(:,5))
        call boost(g,v,p(:,8))
       end if
      else if (ikin <= nt83) then
       sqsl1=m(7)+m(8)
       sqsl2=m(4)+sqsl1
       sqsl3=sqsl2+m(5)
       sqsl4=m(3)+m(6)
       if (imom /= 1) then
        q1=p(:,7)+p(:,8)
        q2=p(:,4)+q1
        q3=q2+p(:,5)
        q4=p(:,3)+p(:,6)
       end if
       if (ikin == 156) then
       sqsu3=ecm-sqsl4
       call mapakk(imom,x(3),q3,sqscut,sqsl3,sqsu3,s3,sqs3,ds3)
       sqsu2=sqs3-m(5)
       call mapbkk(imom,x(2),q2,md,zero,sqsl2,sqsu2,s2,sqs2,ds2)
       sqsu1=sqs2-m(4)
       call mapbkk(imom,x(1),q1,mw,gamw,sqsl1,sqsu1,s1,sqs1,ds1)
       sqsu4=ecm-sqs3
       call mapakk(imom,x(4),q4,sqscut,sqsl4,sqsu4,s4,sqs4,ds4)
       end if
       if (ikin == 157) then
       sqsu3=ecm-sqsl4
       call mapakk(imom,x(3),q3,sqscut,sqsl3,sqsu3,s3,sqs3,ds3)
       sqsu2=sqs3-m(5)
       call mapbkk(imom,x(2),q2,md,zero,sqsl2,sqsu2,s2,sqs2,ds2)
       sqsu1=sqs2-m(4)
       call mapbkk(imom,x(1),q1,mw,gamw,sqsl1,sqsu1,s1,sqs1,ds1)
       sqsu4=ecm-sqs3
       call mapakk(imom,x(4),q4,sqscut,sqsl4,sqsu4,s4,sqs4,ds4)
       end if
       if (ikin == 158) then
       sqsu3=ecm-sqsl4
       call mapakk(imom,x(3),q3,sqscut,sqsl3,sqsu3,s3,sqs3,ds3)
       sqsu2=sqs3-m(5)
       call mapbkk(imom,x(2),q2,md,zero,sqsl2,sqsu2,s2,sqs2,ds2)
       sqsu1=sqs2-m(4)
       call mapbkk(imom,x(1),q1,mw,gamw,sqsl1,sqsu1,s1,sqs1,ds1)
       sqsu4=ecm-sqs3
       call mapbkk(imom,x(4),q4,mz,gamz,sqsl4,sqsu4,s4,sqs4,ds4)
       end if
       if (ikin == 159) then
       sqsu3=ecm-sqsl4
       call mapakk(imom,x(3),q3,sqscut,sqsl3,sqsu3,s3,sqs3,ds3)
       sqsu2=sqs3-m(5)
       call mapbkk(imom,x(2),q2,md,zero,sqsl2,sqsu2,s2,sqs2,ds2)
       sqsu1=sqs2-m(4)
       call mapbkk(imom,x(1),q1,mw,gamw,sqsl1,sqsu1,s1,sqs1,ds1)
       sqsu4=ecm-sqs3
       call mapakk(imom,x(4),q4,sqscut,sqsl4,sqsu4,s4,sqs4,ds4)
       end if
       if (ikin == 160) then
       sqsu3=ecm-sqsl4
       call mapakk(imom,x(3),q3,sqscut,sqsl3,sqsu3,s3,sqs3,ds3)
       sqsu2=sqs3-m(5)
       call mapbkk(imom,x(2),q2,md,zero,sqsl2,sqsu2,s2,sqs2,ds2)
       sqsu1=sqs2-m(4)
       call mapbkk(imom,x(1),q1,mw,gamw,sqsl1,sqsu1,s1,sqs1,ds1)
       sqsu4=ecm-sqs3
       call mapakk(imom,x(4),q4,sqscut,sqsl4,sqsu4,s4,sqs4,ds4)
       end if
       if (ikin == 161) then
       sqsu3=ecm-sqsl4
       call mapakk(imom,x(3),q3,sqscut,sqsl3,sqsu3,s3,sqs3,ds3)
       sqsu2=sqs3-m(5)
       call mapbkk(imom,x(2),q2,md,zero,sqsl2,sqsu2,s2,sqs2,ds2)
       sqsu1=sqs2-m(4)
       call mapbkk(imom,x(1),q1,mw,gamw,sqsl1,sqsu1,s1,sqs1,ds1)
       sqsu4=ecm-sqs3
       call mapbkk(imom,x(4),q4,mz,gamz,sqsl4,sqsu4,s4,sqs4,ds4)
       end if
       if (ikin == 162) then
       sqsu3=ecm-sqsl4
       call mapbkk(imom,x(3),q3,mz,gamz,sqsl3,sqsu3,s3,sqs3,ds3)
       sqsu2=sqs3-m(5)
       call mapbkk(imom,x(2),q2,md,zero,sqsl2,sqsu2,s2,sqs2,ds2)
       sqsu1=sqs2-m(4)
       call mapbkk(imom,x(1),q1,mw,gamw,sqsl1,sqsu1,s1,sqs1,ds1)
       sqsu4=ecm-sqs3
       call mapakk(imom,x(4),q4,sqscut,sqsl4,sqsu4,s4,sqs4,ds4)
       end if
       if (ikin == 163) then
       sqsu3=ecm-sqsl4
       call mapbkk(imom,x(3),q3,mz,gamz,sqsl3,sqsu3,s3,sqs3,ds3)
       sqsu2=sqs3-m(5)
       call mapbkk(imom,x(2),q2,md,zero,sqsl2,sqsu2,s2,sqs2,ds2)
       sqsu1=sqs2-m(4)
       call mapbkk(imom,x(1),q1,mw,gamw,sqsl1,sqsu1,s1,sqs1,ds1)
       sqsu4=ecm-sqs3
       call mapakk(imom,x(4),q4,sqscut,sqsl4,sqsu4,s4,sqs4,ds4)
       end if
       if (ikin == 164) then
       sqsu3=ecm-sqsl4
       call mapbkk(imom,x(3),q3,mz,gamz,sqsl3,sqsu3,s3,sqs3,ds3)
       sqsu2=sqs3-m(5)
       call mapbkk(imom,x(2),q2,md,zero,sqsl2,sqsu2,s2,sqs2,ds2)
       sqsu1=sqs2-m(4)
       call mapbkk(imom,x(1),q1,mw,gamw,sqsl1,sqsu1,s1,sqs1,ds1)
       sqsu4=ecm-sqs3
       call mapbkk(imom,x(4),q4,mz,gamz,sqsl4,sqsu4,s4,sqs4,ds4)
       end if
       call kinff(imom,sqs1,m(7),m(8),x(5:6),p(:,7),p(:,8),dl1)
       call kinff(imom,sqs2,m(4),sqs1,x(7:8),p(:,4),q1,dl2)
       call kinff(imom,sqs3,sqs2,m(5),x(9:10),q2,p(:,5),dl3)
       call kinff(imom,sqs4,m(3),m(6),x(11:12),p(:,3),p(:,6),dl4)
       call kinff(imom,ecm,sqs3,sqs4,x(13:14),q3,q4,dlips)
       dlips=dlips*ds1*ds2*ds3*ds4
     &            *dl1*dl2*dl3*dl4
       if (dlips <= 0.d0) then
        dlips=0.d0
        return
       end if
       if (imom == 1 .and. dlips > 0.d0) then
        v=q1(1:)/q1(0)
        g=q1(0)/sqs1
        call boost(g,v,p(:,7))
        call boost(g,v,p(:,8))
        v=q2(1:)/q2(0)
        g=q2(0)/sqs2
        call boost(g,v,p(:,4))
        call boost(g,v,p(:,7))
        call boost(g,v,p(:,8))
        v=q3(1:)/q3(0)
        g=q3(0)/sqs3
        call boost(g,v,p(:,4))
        call boost(g,v,p(:,7))
        call boost(g,v,p(:,8))
        call boost(g,v,p(:,5))
        v=q4(1:)/q4(0)
        g=q4(0)/sqs4
        call boost(g,v,p(:,3))
        call boost(g,v,p(:,6))
       end if
      else if (ikin <= nt84) then
       sqsl1=m(7)+m(8)
       sqsl2=sqsl1+m(5)
       sqsl3=m(4)+sqsl2
       sqsl4=m(3)+m(6)
       if (imom /= 1) then
        q1=p(:,7)+p(:,8)
        q2=q1+p(:,5)
        q3=p(:,4)+q2
        q4=p(:,3)+p(:,6)
       end if
       if (ikin == 165) then
       sqsu3=ecm-sqsl4
       call mapakk(imom,x(3),q3,sqscut,sqsl3,sqsu3,s3,sqs3,ds3)
       sqsu2=sqs3-m(4)
       call mapbkk(imom,x(2),q2,mu,zero,sqsl2,sqsu2,s2,sqs2,ds2)
       sqsu1=sqs2-m(5)
       call mapbkk(imom,x(1),q1,mw,gamw,sqsl1,sqsu1,s1,sqs1,ds1)
       sqsu4=ecm-sqs3
       call mapakk(imom,x(4),q4,sqscut,sqsl4,sqsu4,s4,sqs4,ds4)
       end if
       if (ikin == 166) then
       sqsu3=ecm-sqsl4
       call mapakk(imom,x(3),q3,sqscut,sqsl3,sqsu3,s3,sqs3,ds3)
       sqsu2=sqs3-m(4)
       call mapbkk(imom,x(2),q2,mu,zero,sqsl2,sqsu2,s2,sqs2,ds2)
       sqsu1=sqs2-m(5)
       call mapbkk(imom,x(1),q1,mw,gamw,sqsl1,sqsu1,s1,sqs1,ds1)
       sqsu4=ecm-sqs3
       call mapakk(imom,x(4),q4,sqscut,sqsl4,sqsu4,s4,sqs4,ds4)
       end if
       if (ikin == 167) then
       sqsu3=ecm-sqsl4
       call mapakk(imom,x(3),q3,sqscut,sqsl3,sqsu3,s3,sqs3,ds3)
       sqsu2=sqs3-m(4)
       call mapbkk(imom,x(2),q2,mu,zero,sqsl2,sqsu2,s2,sqs2,ds2)
       sqsu1=sqs2-m(5)
       call mapbkk(imom,x(1),q1,mw,gamw,sqsl1,sqsu1,s1,sqs1,ds1)
       sqsu4=ecm-sqs3
       call mapbkk(imom,x(4),q4,mz,gamz,sqsl4,sqsu4,s4,sqs4,ds4)
       end if
       if (ikin == 168) then
       sqsu3=ecm-sqsl4
       call mapakk(imom,x(3),q3,sqscut,sqsl3,sqsu3,s3,sqs3,ds3)
       sqsu2=sqs3-m(4)
       call mapbkk(imom,x(2),q2,mu,zero,sqsl2,sqsu2,s2,sqs2,ds2)
       sqsu1=sqs2-m(5)
       call mapbkk(imom,x(1),q1,mw,gamw,sqsl1,sqsu1,s1,sqs1,ds1)
       sqsu4=ecm-sqs3
       call mapakk(imom,x(4),q4,sqscut,sqsl4,sqsu4,s4,sqs4,ds4)
       end if
       if (ikin == 169) then
       sqsu3=ecm-sqsl4
       call mapakk(imom,x(3),q3,sqscut,sqsl3,sqsu3,s3,sqs3,ds3)
       sqsu2=sqs3-m(4)
       call mapbkk(imom,x(2),q2,mu,zero,sqsl2,sqsu2,s2,sqs2,ds2)
       sqsu1=sqs2-m(5)
       call mapbkk(imom,x(1),q1,mw,gamw,sqsl1,sqsu1,s1,sqs1,ds1)
       sqsu4=ecm-sqs3
       call mapakk(imom,x(4),q4,sqscut,sqsl4,sqsu4,s4,sqs4,ds4)
       end if
       if (ikin == 170) then
       sqsu3=ecm-sqsl4
       call mapakk(imom,x(3),q3,sqscut,sqsl3,sqsu3,s3,sqs3,ds3)
       sqsu2=sqs3-m(4)
       call mapbkk(imom,x(2),q2,mu,zero,sqsl2,sqsu2,s2,sqs2,ds2)
       sqsu1=sqs2-m(5)
       call mapbkk(imom,x(1),q1,mw,gamw,sqsl1,sqsu1,s1,sqs1,ds1)
       sqsu4=ecm-sqs3
       call mapbkk(imom,x(4),q4,mz,gamz,sqsl4,sqsu4,s4,sqs4,ds4)
       end if
       if (ikin == 171) then
       sqsu3=ecm-sqsl4
       call mapbkk(imom,x(3),q3,mz,gamz,sqsl3,sqsu3,s3,sqs3,ds3)
       sqsu2=sqs3-m(4)
       call mapbkk(imom,x(2),q2,mu,zero,sqsl2,sqsu2,s2,sqs2,ds2)
       sqsu1=sqs2-m(5)
       call mapbkk(imom,x(1),q1,mw,gamw,sqsl1,sqsu1,s1,sqs1,ds1)
       sqsu4=ecm-sqs3
       call mapakk(imom,x(4),q4,sqscut,sqsl4,sqsu4,s4,sqs4,ds4)
       end if
       if (ikin == 172) then
       sqsu3=ecm-sqsl4
       call mapbkk(imom,x(3),q3,mz,gamz,sqsl3,sqsu3,s3,sqs3,ds3)
       sqsu2=sqs3-m(4)
       call mapbkk(imom,x(2),q2,mu,zero,sqsl2,sqsu2,s2,sqs2,ds2)
       sqsu1=sqs2-m(5)
       call mapbkk(imom,x(1),q1,mw,gamw,sqsl1,sqsu1,s1,sqs1,ds1)
       sqsu4=ecm-sqs3
       call mapakk(imom,x(4),q4,sqscut,sqsl4,sqsu4,s4,sqs4,ds4)
       end if
       if (ikin == 173) then
       sqsu3=ecm-sqsl4
       call mapbkk(imom,x(3),q3,mz,gamz,sqsl3,sqsu3,s3,sqs3,ds3)
       sqsu2=sqs3-m(4)
       call mapbkk(imom,x(2),q2,mu,zero,sqsl2,sqsu2,s2,sqs2,ds2)
       sqsu1=sqs2-m(5)
       call mapbkk(imom,x(1),q1,mw,gamw,sqsl1,sqsu1,s1,sqs1,ds1)
       sqsu4=ecm-sqs3
       call mapbkk(imom,x(4),q4,mz,gamz,sqsl4,sqsu4,s4,sqs4,ds4)
       end if
       call kinff(imom,sqs1,m(7),m(8),x(5:6),p(:,7),p(:,8),dl1)
       call kinff(imom,sqs2,sqs1,m(5),x(7:8),q1,p(:,5),dl2)
       call kinff(imom,sqs3,m(4),sqs2,x(9:10),p(:,4),q2,dl3)
       call kinff(imom,sqs4,m(3),m(6),x(11:12),p(:,3),p(:,6),dl4)
       call kinff(imom,ecm,sqs3,sqs4,x(13:14),q3,q4,dlips)
       dlips=dlips*ds1*ds2*ds3*ds4
     &            *dl1*dl2*dl3*dl4
       if (dlips <= 0.d0) then
        dlips=0.d0
        return
       end if
       if (imom == 1 .and. dlips > 0.d0) then
        v=q1(1:)/q1(0)
        g=q1(0)/sqs1
        call boost(g,v,p(:,7))
        call boost(g,v,p(:,8))
        v=q2(1:)/q2(0)
        g=q2(0)/sqs2
        call boost(g,v,p(:,7))
        call boost(g,v,p(:,8))
        call boost(g,v,p(:,5))
        v=q3(1:)/q3(0)
        g=q3(0)/sqs3
        call boost(g,v,p(:,4))
        call boost(g,v,p(:,7))
        call boost(g,v,p(:,8))
        call boost(g,v,p(:,5))
        v=q4(1:)/q4(0)
        g=q4(0)/sqs4
        call boost(g,v,p(:,3))
        call boost(g,v,p(:,6))
       end if
      else if (ikin <= nt85) then
       sqsl1=m(4)+m(5)
       sqsl2=sqsl1+m(8)
       sqsl3=m(7)+sqsl2
       sqsl4=m(3)+m(6)
       if (imom /= 1) then
        q1=p(:,4)+p(:,5)
        q2=q1+p(:,8)
        q3=p(:,7)+q2
        q4=p(:,3)+p(:,6)
       end if
       if (ikin == 174) then
       sqsu3=ecm-sqsl4
       call mapakk(imom,x(3),q3,sqscut,sqsl3,sqsu3,s3,sqs3,ds3)
       sqsu2=sqs3-m(7)
       call mapbkk(imom,x(2),q2,mmu,zero,sqsl2,sqsu2,s2,sqs2,ds2)
       sqsu1=sqs2-m(8)
       call mapbkk(imom,x(1),q1,mw,gamw,sqsl1,sqsu1,s1,sqs1,ds1)
       sqsu4=ecm-sqs3
       call mapakk(imom,x(4),q4,sqscut,sqsl4,sqsu4,s4,sqs4,ds4)
       end if
       if (ikin == 175) then
       sqsu3=ecm-sqsl4
       call mapakk(imom,x(3),q3,sqscut,sqsl3,sqsu3,s3,sqs3,ds3)
       sqsu2=sqs3-m(7)
       call mapbkk(imom,x(2),q2,mmu,zero,sqsl2,sqsu2,s2,sqs2,ds2)
       sqsu1=sqs2-m(8)
       call mapbkk(imom,x(1),q1,mw,gamw,sqsl1,sqsu1,s1,sqs1,ds1)
       sqsu4=ecm-sqs3
       call mapakk(imom,x(4),q4,sqscut,sqsl4,sqsu4,s4,sqs4,ds4)
       end if
       if (ikin == 176) then
       sqsu3=ecm-sqsl4
       call mapakk(imom,x(3),q3,sqscut,sqsl3,sqsu3,s3,sqs3,ds3)
       sqsu2=sqs3-m(7)
       call mapbkk(imom,x(2),q2,mmu,zero,sqsl2,sqsu2,s2,sqs2,ds2)
       sqsu1=sqs2-m(8)
       call mapbkk(imom,x(1),q1,mw,gamw,sqsl1,sqsu1,s1,sqs1,ds1)
       sqsu4=ecm-sqs3
       call mapbkk(imom,x(4),q4,mz,gamz,sqsl4,sqsu4,s4,sqs4,ds4)
       end if
       if (ikin == 177) then
       sqsu3=ecm-sqsl4
       call mapbkk(imom,x(3),q3,mz,gamz,sqsl3,sqsu3,s3,sqs3,ds3)
       sqsu2=sqs3-m(7)
       call mapbkk(imom,x(2),q2,mmu,zero,sqsl2,sqsu2,s2,sqs2,ds2)
       sqsu1=sqs2-m(8)
       call mapbkk(imom,x(1),q1,mw,gamw,sqsl1,sqsu1,s1,sqs1,ds1)
       sqsu4=ecm-sqs3
       call mapakk(imom,x(4),q4,sqscut,sqsl4,sqsu4,s4,sqs4,ds4)
       end if
       if (ikin == 178) then
       sqsu3=ecm-sqsl4
       call mapbkk(imom,x(3),q3,mz,gamz,sqsl3,sqsu3,s3,sqs3,ds3)
       sqsu2=sqs3-m(7)
       call mapbkk(imom,x(2),q2,mmu,zero,sqsl2,sqsu2,s2,sqs2,ds2)
       sqsu1=sqs2-m(8)
       call mapbkk(imom,x(1),q1,mw,gamw,sqsl1,sqsu1,s1,sqs1,ds1)
       sqsu4=ecm-sqs3
       call mapakk(imom,x(4),q4,sqscut,sqsl4,sqsu4,s4,sqs4,ds4)
       end if
       if (ikin == 179) then
       sqsu3=ecm-sqsl4
       call mapbkk(imom,x(3),q3,mz,gamz,sqsl3,sqsu3,s3,sqs3,ds3)
       sqsu2=sqs3-m(7)
       call mapbkk(imom,x(2),q2,mmu,zero,sqsl2,sqsu2,s2,sqs2,ds2)
       sqsu1=sqs2-m(8)
       call mapbkk(imom,x(1),q1,mw,gamw,sqsl1,sqsu1,s1,sqs1,ds1)
       sqsu4=ecm-sqs3
       call mapbkk(imom,x(4),q4,mz,gamz,sqsl4,sqsu4,s4,sqs4,ds4)
       end if
       call kinff(imom,sqs1,m(4),m(5),x(5:6),p(:,4),p(:,5),dl1)
       call kinff(imom,sqs2,sqs1,m(8),x(7:8),q1,p(:,8),dl2)
       call kinff(imom,sqs3,m(7),sqs2,x(9:10),p(:,7),q2,dl3)
       call kinff(imom,sqs4,m(3),m(6),x(11:12),p(:,3),p(:,6),dl4)
       call kinff(imom,ecm,sqs3,sqs4,x(13:14),q3,q4,dlips)
       dlips=dlips*ds1*ds2*ds3*ds4
     &            *dl1*dl2*dl3*dl4
       if (dlips <= 0.d0) then
        dlips=0.d0
        return
       end if
       if (imom == 1 .and. dlips > 0.d0) then
        v=q1(1:)/q1(0)
        g=q1(0)/sqs1
        call boost(g,v,p(:,4))
        call boost(g,v,p(:,5))
        v=q2(1:)/q2(0)
        g=q2(0)/sqs2
        call boost(g,v,p(:,4))
        call boost(g,v,p(:,5))
        call boost(g,v,p(:,8))
        v=q3(1:)/q3(0)
        g=q3(0)/sqs3
        call boost(g,v,p(:,7))
        call boost(g,v,p(:,4))
        call boost(g,v,p(:,5))
        call boost(g,v,p(:,8))
        v=q4(1:)/q4(0)
        g=q4(0)/sqs4
        call boost(g,v,p(:,3))
        call boost(g,v,p(:,6))
       end if
      else if (ikin <= nt86) then
       sqsl1=m(4)+m(5)
       sqsl2=m(7)+m(8)
       sqsl3=sqsl1+sqsl2
       sqsl4=m(3)+m(6)
       if (imom /= 1) then
        q1=p(:,4)+p(:,5)
        q2=p(:,7)+p(:,8)
        q3=q1+q2
        q4=p(:,3)+p(:,6)
       end if
       if (ikin == 180) then
       sqsu3=ecm-sqsl4
       call mapakk(imom,x(3),q3,sqscut,sqsl3,sqsu3,s3,sqs3,ds3)
       sqsu2=sqs3-sqsl1
       call mapbkk(imom,x(2),q2,mw,gamw,sqsl2,sqsu2,s2,sqs2,ds2)
       sqsu1=sqs3-sqs2
       call mapbkk(imom,x(1),q1,mw,gamw,sqsl1,sqsu1,s1,sqs1,ds1)
       sqsu4=ecm-sqs3
       call mapakk(imom,x(4),q4,sqscut,sqsl4,sqsu4,s4,sqs4,ds4)
       end if
       if (ikin == 181) then
       sqsu3=ecm-sqsl4
       call mapakk(imom,x(3),q3,sqscut,sqsl3,sqsu3,s3,sqs3,ds3)
       sqsu2=sqs3-sqsl1
       call mapbkk(imom,x(2),q2,mw,gamw,sqsl2,sqsu2,s2,sqs2,ds2)
       sqsu1=sqs3-sqs2
       call mapbkk(imom,x(1),q1,mw,gamw,sqsl1,sqsu1,s1,sqs1,ds1)
       sqsu4=ecm-sqs3
       call mapakk(imom,x(4),q4,sqscut,sqsl4,sqsu4,s4,sqs4,ds4)
       end if
       if (ikin == 182) then
       sqsu3=ecm-sqsl4
       call mapakk(imom,x(3),q3,sqscut,sqsl3,sqsu3,s3,sqs3,ds3)
       sqsu2=sqs3-sqsl1
       call mapbkk(imom,x(2),q2,mw,gamw,sqsl2,sqsu2,s2,sqs2,ds2)
       sqsu1=sqs3-sqs2
       call mapbkk(imom,x(1),q1,mw,gamw,sqsl1,sqsu1,s1,sqs1,ds1)
       sqsu4=ecm-sqs3
       call mapbkk(imom,x(4),q4,mz,gamz,sqsl4,sqsu4,s4,sqs4,ds4)
       end if
       if (ikin == 183) then
       sqsu3=ecm-sqsl4
       call mapbkk(imom,x(3),q3,mz,gamz,sqsl3,sqsu3,s3,sqs3,ds3)
       sqsu2=sqs3-sqsl1
       call mapbkk(imom,x(2),q2,mw,gamw,sqsl2,sqsu2,s2,sqs2,ds2)
       sqsu1=sqs3-sqs2
       call mapbkk(imom,x(1),q1,mw,gamw,sqsl1,sqsu1,s1,sqs1,ds1)
       sqsu4=ecm-sqs3
       call mapakk(imom,x(4),q4,sqscut,sqsl4,sqsu4,s4,sqs4,ds4)
       end if
       if (ikin == 184) then
       sqsu3=ecm-sqsl4
       call mapbkk(imom,x(3),q3,mz,gamz,sqsl3,sqsu3,s3,sqs3,ds3)
       sqsu2=sqs3-sqsl1
       call mapbkk(imom,x(2),q2,mw,gamw,sqsl2,sqsu2,s2,sqs2,ds2)
       sqsu1=sqs3-sqs2
       call mapbkk(imom,x(1),q1,mw,gamw,sqsl1,sqsu1,s1,sqs1,ds1)
       sqsu4=ecm-sqs3
       call mapakk(imom,x(4),q4,sqscut,sqsl4,sqsu4,s4,sqs4,ds4)
       end if
       if (ikin == 185) then
       sqsu3=ecm-sqsl4
       call mapbkk(imom,x(3),q3,mz,gamz,sqsl3,sqsu3,s3,sqs3,ds3)
       sqsu2=sqs3-sqsl1
       call mapbkk(imom,x(2),q2,mw,gamw,sqsl2,sqsu2,s2,sqs2,ds2)
       sqsu1=sqs3-sqs2
       call mapbkk(imom,x(1),q1,mw,gamw,sqsl1,sqsu1,s1,sqs1,ds1)
       sqsu4=ecm-sqs3
       call mapbkk(imom,x(4),q4,mz,gamz,sqsl4,sqsu4,s4,sqs4,ds4)
       end if
       call kinff(imom,sqs1,m(4),m(5),x(5:6),p(:,4),p(:,5),dl1)
       call kinff(imom,sqs2,m(7),m(8),x(7:8),p(:,7),p(:,8),dl2)
       call kinff(imom,sqs3,sqs1,sqs2,x(9:10),q1,q2,dl3)
       call kinff(imom,sqs4,m(3),m(6),x(11:12),p(:,3),p(:,6),dl4)
       call kinff(imom,ecm,sqs3,sqs4,x(13:14),q3,q4,dlips)
       dlips=dlips*ds1*ds2*ds3*ds4
     &            *dl1*dl2*dl3*dl4
       if (dlips <= 0.d0) then
        dlips=0.d0
        return
       end if
       if (imom == 1 .and. dlips > 0.d0) then
        v=q1(1:)/q1(0)
        g=q1(0)/sqs1
        call boost(g,v,p(:,4))
        call boost(g,v,p(:,5))
        v=q2(1:)/q2(0)
        g=q2(0)/sqs2
        call boost(g,v,p(:,7))
        call boost(g,v,p(:,8))
        v=q3(1:)/q3(0)
        g=q3(0)/sqs3
        call boost(g,v,p(:,4))
        call boost(g,v,p(:,5))
        call boost(g,v,p(:,7))
        call boost(g,v,p(:,8))
        v=q4(1:)/q4(0)
        g=q4(0)/sqs4
        call boost(g,v,p(:,3))
        call boost(g,v,p(:,6))
       end if
      else if (ikin <= nt87) then
       sqsl1=m(4)+m(5)
       sqsl2=m(7)+sqsl1
       sqsl3=sqsl2+m(8)
       sqsl4=m(3)+m(6)
       if (imom /= 1) then
        q1=p(:,4)+p(:,5)
        q2=p(:,7)+q1
        q3=q2+p(:,8)
        q4=p(:,3)+p(:,6)
       end if
       if (ikin == 186) then
       sqsu3=ecm-sqsl4
       call mapbkk(imom,x(3),q3,mz,gamz,sqsl3,sqsu3,s3,sqs3,ds3)
       sqsu2=sqs3-m(8)
       call mapbkk(imom,x(2),q2,zero,zero,sqsl2,sqsu2,s2,sqs2,ds2)
       sqsu1=sqs2-m(7)
       call mapbkk(imom,x(1),q1,mw,gamw,sqsl1,sqsu1,s1,sqs1,ds1)
       sqsu4=ecm-sqs3
       call mapakk(imom,x(4),q4,sqscut,sqsl4,sqsu4,s4,sqs4,ds4)
       end if
       if (ikin == 187) then
       sqsu3=ecm-sqsl4
       call mapbkk(imom,x(3),q3,mz,gamz,sqsl3,sqsu3,s3,sqs3,ds3)
       sqsu2=sqs3-m(8)
       call mapbkk(imom,x(2),q2,zero,zero,sqsl2,sqsu2,s2,sqs2,ds2)
       sqsu1=sqs2-m(7)
       call mapbkk(imom,x(1),q1,mw,gamw,sqsl1,sqsu1,s1,sqs1,ds1)
       sqsu4=ecm-sqs3
       call mapakk(imom,x(4),q4,sqscut,sqsl4,sqsu4,s4,sqs4,ds4)
       end if
       if (ikin == 188) then
       sqsu3=ecm-sqsl4
       call mapbkk(imom,x(3),q3,mz,gamz,sqsl3,sqsu3,s3,sqs3,ds3)
       sqsu2=sqs3-m(8)
       call mapbkk(imom,x(2),q2,zero,zero,sqsl2,sqsu2,s2,sqs2,ds2)
       sqsu1=sqs2-m(7)
       call mapbkk(imom,x(1),q1,mw,gamw,sqsl1,sqsu1,s1,sqs1,ds1)
       sqsu4=ecm-sqs3
       call mapbkk(imom,x(4),q4,mz,gamz,sqsl4,sqsu4,s4,sqs4,ds4)
       end if
       call kinff(imom,sqs1,m(4),m(5),x(5:6),p(:,4),p(:,5),dl1)
       call kinff(imom,sqs2,m(7),sqs1,x(7:8),p(:,7),q1,dl2)
       call kinff(imom,sqs3,sqs2,m(8),x(9:10),q2,p(:,8),dl3)
       call kinff(imom,sqs4,m(3),m(6),x(11:12),p(:,3),p(:,6),dl4)
       call kinff(imom,ecm,sqs3,sqs4,x(13:14),q3,q4,dlips)
       dlips=dlips*ds1*ds2*ds3*ds4
     &            *dl1*dl2*dl3*dl4
       if (dlips <= 0.d0) then
        dlips=0.d0
        return
       end if
       if (imom == 1 .and. dlips > 0.d0) then
        v=q1(1:)/q1(0)
        g=q1(0)/sqs1
        call boost(g,v,p(:,4))
        call boost(g,v,p(:,5))
        v=q2(1:)/q2(0)
        g=q2(0)/sqs2
        call boost(g,v,p(:,7))
        call boost(g,v,p(:,4))
        call boost(g,v,p(:,5))
        v=q3(1:)/q3(0)
        g=q3(0)/sqs3
        call boost(g,v,p(:,7))
        call boost(g,v,p(:,4))
        call boost(g,v,p(:,5))
        call boost(g,v,p(:,8))
        v=q4(1:)/q4(0)
        g=q4(0)/sqs4
        call boost(g,v,p(:,3))
        call boost(g,v,p(:,6))
       end if
      else if (ikin <= nt88) then
       sqsl1=m(4)+m(5)
       sqsl2=m(7)+m(8)
       sqsl3=sqsl2+sqsl1
       sqsl4=m(3)+m(6)
       if (imom /= 1) then
        q1=p(:,4)+p(:,5)
        q2=p(:,7)+p(:,8)
        q3=q2+q1
        q4=p(:,3)+p(:,6)
       end if
       if (ikin == 189) then
       sqsu3=ecm-sqsl4
       ds3=(sqsu3-sqsl3)*(sqsu3+sqsl3)
       if (imom == 1) then
        s3=ds3*x(3)+sqsl3*sqsl3
       else
        s3=(q3(0)-q3(3))*(q3(0)+q3(3))-q3(1)*q3(1)-q3(2)*q3(2)
       end if
       sqs3=sqrt(s3)
       sqsu2=sqs3-sqsl1
       call mapbkk(imom,x(2),q2,mw,gamw,sqsl2,sqsu2,s2,sqs2,ds2)
       sqsu1=sqs3-sqs2
       call mapbkk(imom,x(1),q1,mw,gamw,sqsl1,sqsu1,s1,sqs1,ds1)
       sqsu4=ecm-sqs3
       call mapakk(imom,x(4),q4,sqscut,sqsl4,sqsu4,s4,sqs4,ds4)
       end if
       if (ikin == 190) then
       sqsu3=ecm-sqsl4
       ds3=(sqsu3-sqsl3)*(sqsu3+sqsl3)
       if (imom == 1) then
        s3=ds3*x(3)+sqsl3*sqsl3
       else
        s3=(q3(0)-q3(3))*(q3(0)+q3(3))-q3(1)*q3(1)-q3(2)*q3(2)
       end if
       sqs3=sqrt(s3)
       sqsu2=sqs3-sqsl1
       call mapbkk(imom,x(2),q2,mw,gamw,sqsl2,sqsu2,s2,sqs2,ds2)
       sqsu1=sqs3-sqs2
       call mapbkk(imom,x(1),q1,mw,gamw,sqsl1,sqsu1,s1,sqs1,ds1)
       sqsu4=ecm-sqs3
       call mapakk(imom,x(4),q4,sqscut,sqsl4,sqsu4,s4,sqs4,ds4)
       end if
       if (ikin == 191) then
       sqsu3=ecm-sqsl4
       ds3=(sqsu3-sqsl3)*(sqsu3+sqsl3)
       if (imom == 1) then
        s3=ds3*x(3)+sqsl3*sqsl3
       else
        s3=(q3(0)-q3(3))*(q3(0)+q3(3))-q3(1)*q3(1)-q3(2)*q3(2)
       end if
       sqs3=sqrt(s3)
       sqsu2=sqs3-sqsl1
       call mapbkk(imom,x(2),q2,mw,gamw,sqsl2,sqsu2,s2,sqs2,ds2)
       sqsu1=sqs3-sqs2
       call mapbkk(imom,x(1),q1,mw,gamw,sqsl1,sqsu1,s1,sqs1,ds1)
       sqsu4=ecm-sqs3
       call mapbkk(imom,x(4),q4,mz,gamz,sqsl4,sqsu4,s4,sqs4,ds4)
       end if
       call kinff(imom,sqs1,m(4),m(5),x(5:6),p(:,4),p(:,5),dl1)
       call kinff(imom,sqs2,m(7),m(8),x(7:8),p(:,7),p(:,8),dl2)
       call kinff(imom,sqs3,sqs2,sqs1,x(9:10),q2,q1,dl3)
       call kinff(imom,sqs4,m(3),m(6),x(11:12),p(:,3),p(:,6),dl4)
       call kinff(imom,ecm,sqs3,sqs4,x(13:14),q3,q4,dlips)
       dlips=dlips*ds1*ds2*ds3*ds4
     &            *dl1*dl2*dl3*dl4
       if (dlips <= 0.d0) then
        dlips=0.d0
        return
       end if
       if (imom == 1 .and. dlips > 0.d0) then
        v=q1(1:)/q1(0)
        g=q1(0)/sqs1
        call boost(g,v,p(:,4))
        call boost(g,v,p(:,5))
        v=q2(1:)/q2(0)
        g=q2(0)/sqs2
        call boost(g,v,p(:,7))
        call boost(g,v,p(:,8))
        v=q3(1:)/q3(0)
        g=q3(0)/sqs3
        call boost(g,v,p(:,7))
        call boost(g,v,p(:,8))
        call boost(g,v,p(:,4))
        call boost(g,v,p(:,5))
        v=q4(1:)/q4(0)
        g=q4(0)/sqs4
        call boost(g,v,p(:,3))
        call boost(g,v,p(:,6))
       end if
      else if (ikin <= nt90) then
       sqsl1=m(4)+m(5)
       sqsl2=m(7)+m(8)
       sqsl3=m(3)+m(6)
       sqsl4=sqsl2+sqsl3
       if (imom /= 1) then
        q1=p(:,4)+p(:,5)
        q2=p(:,7)+p(:,8)
        q3=p(:,3)+p(:,6)
        q4=q2+q3
       end if
       if (ikin == 192) then
       sqsu1=ecm-sqsl4
       call mapbkk(imom,x(1),q1,mw,gamw,sqsl1,sqsu1,s1,sqs1,ds1)
       sqsu4=ecm-sqs1
       ds4=(sqsu4-sqsl4)*(sqsu4+sqsl4)
       if (imom == 1) then
        s4=ds4*x(4)+sqsl4*sqsl4
       else
        s4=(q4(0)-q4(3))*(q4(0)+q4(3))-q4(1)*q4(1)-q4(2)*q4(2)
       end if
       sqs4=sqrt(s4)
       sqsu3=sqs4-sqsl2
       call mapakk(imom,x(3),q3,sqscut,sqsl3,sqsu3,s3,sqs3,ds3)
       sqsu2=sqs4-sqs3
       call mapbkk(imom,x(2),q2,mw,gamw,sqsl2,sqsu2,s2,sqs2,ds2)
       end if
       if (ikin == 193) then
       sqsu1=ecm-sqsl4
       call mapbkk(imom,x(1),q1,mw,gamw,sqsl1,sqsu1,s1,sqs1,ds1)
       sqsu4=ecm-sqs1
       ds4=(sqsu4-sqsl4)*(sqsu4+sqsl4)
       if (imom == 1) then
        s4=ds4*x(4)+sqsl4*sqsl4
       else
        s4=(q4(0)-q4(3))*(q4(0)+q4(3))-q4(1)*q4(1)-q4(2)*q4(2)
       end if
       sqs4=sqrt(s4)
       sqsu3=sqs4-sqsl2
       call mapakk(imom,x(3),q3,sqscut,sqsl3,sqsu3,s3,sqs3,ds3)
       sqsu2=sqs4-sqs3
       call mapbkk(imom,x(2),q2,mw,gamw,sqsl2,sqsu2,s2,sqs2,ds2)
       end if
       if (ikin == 194) then
       sqsu1=ecm-sqsl4
       call mapbkk(imom,x(1),q1,mw,gamw,sqsl1,sqsu1,s1,sqs1,ds1)
       sqsu4=ecm-sqs1
       ds4=(sqsu4-sqsl4)*(sqsu4+sqsl4)
       if (imom == 1) then
        s4=ds4*x(4)+sqsl4*sqsl4
       else
        s4=(q4(0)-q4(3))*(q4(0)+q4(3))-q4(1)*q4(1)-q4(2)*q4(2)
       end if
       sqs4=sqrt(s4)
       sqsu3=sqs4-sqsl2
       call mapbkk(imom,x(3),q3,mz,gamz,sqsl3,sqsu3,s3,sqs3,ds3)
       sqsu2=sqs4-sqs3
       call mapbkk(imom,x(2),q2,mw,gamw,sqsl2,sqsu2,s2,sqs2,ds2)
       end if
       call kinff(imom,sqs1,m(4),m(5),x(5:6),p(:,4),p(:,5),dl1)
       call kinff(imom,sqs2,m(7),m(8),x(7:8),p(:,7),p(:,8),dl2)
       call kinff(imom,sqs3,m(3),m(6),x(9:10),p(:,3),p(:,6),dl3)
       call kinff(imom,sqs4,sqs2,sqs3,x(11:12),q2,q3,dl4)
       call kinff(imom,ecm,sqs1,sqs4,x(13:14),q1,q4,dlips)
       dlips=dlips*ds1*ds2*ds3*ds4
     &            *dl1*dl2*dl3*dl4
       if (dlips <= 0.d0) then
        dlips=0.d0
        return
       end if
       if (imom == 1 .and. dlips > 0.d0) then
        v=q1(1:)/q1(0)
        g=q1(0)/sqs1
        call boost(g,v,p(:,4))
        call boost(g,v,p(:,5))
        v=q2(1:)/q2(0)
        g=q2(0)/sqs2
        call boost(g,v,p(:,7))
        call boost(g,v,p(:,8))
        v=q3(1:)/q3(0)
        g=q3(0)/sqs3
        call boost(g,v,p(:,3))
        call boost(g,v,p(:,6))
        v=q4(1:)/q4(0)
        g=q4(0)/sqs4
        call boost(g,v,p(:,7))
        call boost(g,v,p(:,8))
        call boost(g,v,p(:,3))
        call boost(g,v,p(:,6))
       end if
      else if (ikin <= nt94) then
       sqsl1=m(7)+m(8)
       sqsl2=m(4)+sqsl1
       sqsl3=m(3)+m(6)
       sqsl4=sqsl3+m(5)
       if (imom /= 1) then
        q1=p(:,7)+p(:,8)
        q2=p(:,4)+q1
        q3=p(:,3)+p(:,6)
        q4=q3+p(:,5)
       end if
       if (ikin == 195) then
       sqsu2=ecm-sqsl4
       call mapbkk(imom,x(2),q2,md,zero,sqsl2,sqsu2,s2,sqs2,ds2)
       sqsu1=sqs2-m(4)
       call mapbkk(imom,x(1),q1,mw,gamw,sqsl1,sqsu1,s1,sqs1,ds1)
       sqsu4=ecm-sqs2
       call mapbkk(imom,x(4),q4,mw,gamw,sqsl4,sqsu4,s4,sqs4,ds4)
       sqsu3=sqs4-m(5)
       call mapakk(imom,x(3),q3,sqscut,sqsl3,sqsu3,s3,sqs3,ds3)
       end if
       if (ikin == 196) then
       sqsu2=ecm-sqsl4
       call mapbkk(imom,x(2),q2,md,zero,sqsl2,sqsu2,s2,sqs2,ds2)
       sqsu1=sqs2-m(4)
       call mapbkk(imom,x(1),q1,mw,gamw,sqsl1,sqsu1,s1,sqs1,ds1)
       sqsu4=ecm-sqs2
       call mapbkk(imom,x(4),q4,mw,gamw,sqsl4,sqsu4,s4,sqs4,ds4)
       sqsu3=sqs4-m(5)
       call mapakk(imom,x(3),q3,sqscut,sqsl3,sqsu3,s3,sqs3,ds3)
       end if
       if (ikin == 197) then
       sqsu2=ecm-sqsl4
       call mapbkk(imom,x(2),q2,md,zero,sqsl2,sqsu2,s2,sqs2,ds2)
       sqsu1=sqs2-m(4)
       call mapbkk(imom,x(1),q1,mw,gamw,sqsl1,sqsu1,s1,sqs1,ds1)
       sqsu4=ecm-sqs2
       call mapbkk(imom,x(4),q4,mw,gamw,sqsl4,sqsu4,s4,sqs4,ds4)
       sqsu3=sqs4-m(5)
       call mapbkk(imom,x(3),q3,mz,gamz,sqsl3,sqsu3,s3,sqs3,ds3)
       end if
       call kinff(imom,sqs1,m(7),m(8),x(5:6),p(:,7),p(:,8),dl1)
       call kinff(imom,sqs2,m(4),sqs1,x(7:8),p(:,4),q1,dl2)
       call kinff(imom,sqs3,m(3),m(6),x(9:10),p(:,3),p(:,6),dl3)
       call kinff(imom,sqs4,sqs3,m(5),x(11:12),q3,p(:,5),dl4)
       call kinff(imom,ecm,sqs2,sqs4,x(13:14),q2,q4,dlips)
       dlips=dlips*ds1*ds2*ds3*ds4
     &            *dl1*dl2*dl3*dl4
       if (dlips <= 0.d0) then
        dlips=0.d0
        return
       end if
       if (imom == 1 .and. dlips > 0.d0) then
        v=q1(1:)/q1(0)
        g=q1(0)/sqs1
        call boost(g,v,p(:,7))
        call boost(g,v,p(:,8))
        v=q2(1:)/q2(0)
        g=q2(0)/sqs2
        call boost(g,v,p(:,4))
        call boost(g,v,p(:,7))
        call boost(g,v,p(:,8))
        v=q3(1:)/q3(0)
        g=q3(0)/sqs3
        call boost(g,v,p(:,3))
        call boost(g,v,p(:,6))
        v=q4(1:)/q4(0)
        g=q4(0)/sqs4
        call boost(g,v,p(:,3))
        call boost(g,v,p(:,6))
        call boost(g,v,p(:,5))
       end if
      end if
 
      end
