      subroutine preamble(unit)

      use extpart

      integer :: unit

      write(unit,4000)
      write(unit,5000)
      write(unit,'(a)') 'c'
      write(unit,'(a$)') 'c                      '
      do i=1,nisp
       write(unit,'(a$)') trim(expc(i))//' '
      end do
      write(unit,'(a$)') ' ->  '
      do i=nisp+1,next-1
       write(unit,'(a$)') trim(expc(i))//' '
      end do
      write(unit,'(a)') trim(expc(next))
      write(unit,'(a)') 'c'
      write(unit,5010) trim(adjustl(prvrsn))
      if (iewk == 1) then
       write(unit,'(a)') 'c taking into account pure EW contributions'
      end if
      if (ihgs == 1) then
       write(unit,'(a)') 'c without the Higgs boson contributions'
      end if
      if (imcs == 1) then
       write(unit,'(a)') 'c with the MC summing over polarizations'
      end if
      write(unit,'(a)') 'c'
      write(unit,5020)
      write(unit,5030)
      write(unit,5040)
      write(unit,5050)
      write(unit,4000)

 4000 format('c=======================================================',
     &       '======================c')
 5000 format('c Matrix element of the process:')
 5010 format('c generated with ',a)
 5020 format('c                            Karol Kolodziej')
 5030 format('c                         University of Silesia')
 5040 format('c                            Katowice, Poland')
 5050 format('c                      e-mail: karol.kolodziej@us.edu.pl')

      write(unit,'(a)') ' '
      write(unit,'(a)') '      subroutine matrixel(p,phi,mat2)'
      write(unit,'(a)') ' '
      write(unit,'(a)') '      use inprms'
      write(unit,'(a)') '      use couplsmkk'
      write(unit,'(a)') '      use hmodkk'
      write(unit,'(a)') '      use pmodkk'
      write(unit,'(a)') '      use umodkk'
      write(unit,'(a)') ' '
      write(unit,'(a)') '      implicit none'
      write(unit,'(a)') ' '
      write(unit,1025) next,nmcs
 1025 format('      integer, parameter :: next=',i2,', nmcs=',i2)
      write(unit,1030)
 1030 format('      real(dp) :: p(0:3,next),phi(nmcs),mat2,comif')
      write(unit,1040)
 1040 format('      integer :: first=1,hl,nexh(next)')
      write(unit,'(a)') ' '

      end 

